<?php
    // Define Permission level constants
    define('pLIST', 1);
    define('pVIEW', 2);
    define('pEDIT', 3);
    define('pREMV', 4);

    // If no GroupID is set, that means this user is a Guest
    if(!isset($_SESSION['Group'])) {
        $_SESSION['EmployeeID'] = -1;
        $_SESSION['Group'] = GUESTS_GROUPID;
    }

    // Load Permissions
    $Group = DB_DataObject::factory('Groups');
    $rows = $Group->get($_SESSION['Group']);

    if (!is_numeric($rows)) {
        redirectLogin('Database error.  Please contact your system administrator.');
    } elseif ($rows < 0) {
        redirectLogin('Unable to find username, please try signing in again.');
    } elseif ($rows > 1) {
        redirectLogin('Database error: duplicate users found.');
    }

    $perm = array(
        sCOMPUTERS      => $Group->ComputersPerm,
        sPRINTERS       => $Group->PrintersPerm,
        sPERIPHERALS    => $Group->PeripheralsPerm,
        sSOFTWARE       => $Group->SoftwarePerm,
        sEMPLOYEES      => $Group->EmployeesPerm,
        sREPORTS        => $Group->ReportsPerm,
        sSUPPORT        => $Group->SupportPerm,
        sSUPPORTLOG     => $Group->SupportPerm, // SupportLog uses Support's
        sKB             => $Group->KBPerm,
        sGROUPS         => $Group->GroupPerm,
        sOUTOFOFFICE    => $Group->OutOfOfficePerm,
        sLOOKUPS        => $Group->LookupsPerm,
        sNEWS           => $Group->NewsPerm,
        sPOLICIES       => $Group->PolicyPerm);

    function Permission($section)
    {
        global $perm;
        return $perm[$section];
    }

    function ListPerm($section) {
        global $perm;
        return ($perm[$section] >= pLIST);
    }

    function ViewPerm($section)
    {
        global $perm;
        return ($perm[$section] >= pVIEW);
    }

    function EditPerm($section)
    {
        global $perm;
        return ($perm[$section] >= pEDIT);
    }

    function RemvPerm($section)
    {
        global $perm;
        return ($perm[$section] >= pREMV);
    }

    function outputNoPermission()
    {
        echo '
            <table class="warning">
                <tr>
                    <td class="invisible"><p class="warning">
                        '.lNO_PERMISSION.'
                    </p></td>
                </tr>
            </table>
';
    }

    function redirectLogin($reason)
    {
        $_SESSION['Login_Text'] = $reason;
        session_write_close();
        die(my_redirect('login.php')."\n</body>\n</html>");
    }

    function PermToString($perm)
    {
        switch ($perm) {
            case 0: return '<img src="images/button_x.png" alt="None" />';
            case 1: return '<img src="images/button_reports.png" alt="List" />';
            case 2: return '<img src="images/button_view.png" alt="View" />';
            case 3: return '<img src="images/button_edit.png" alt="Edit" />';
            case 4: return '<img src="images/button_remove.png" alt="Full" />';
            default: return 'Error';
        }
    }
?>