<?php
    require_once('inc/common.php');

    /**
     * Generate HTML for a View button
     *
     * @param string $section section constant to view
     * @param int $id id of row to view
     * @return string
     * @since Version 2.0
     */
    function ViewButton($section, $id)
    {
        return '<a href="index.php?View='.$section.'&ID='.$id.'" title="View">'.
            '<img src="images/button_view.png" alt="View" /></a>';
    }

    /**
     * Generate HTML for a Edit button
     *
     * @param string $section section constant to edit
     * @param int $id id of row to edit
     * @return string
     * @since Version 2.0
     */
    function EditButton($section, $id)
    {
        return '<a href="index.php?Edit='.$section.'&ID='.$id.'" title="Edit">'.
            '<img src="images/button_edit.png" alt="Edit" /></a>';
    }

    /**
     * Generate HTML for a Remove button
     *
     * @param string $section section constant to remove
     * @param int $id id of row to remove
     * @return string
     * @since Version 2.0
     */
    function RemoveButton($section, $id)
    {
        return '<a href="index.php?Remove='.$section.'&ID='.$id.'" title="Remove">'.
            '<img src="images/button_remove.png" alt="Remove" /></a>';
    }

    /**
     * Generate HTML for an Add New button
     *
     * @param string $section section constant to insert new row into
     * @return string
     * @since Version 2.0
     */
    function AddNewButton($section, $id = NEWID)
    {
        global $SectionSingular;

        return '<a href="index.php?Edit='.$section.'&ID='.$id.'" '.
            'title="'.lADD_NEW.' '.$SectionSingular[$section].'">'.
            '<img src="images/button_add.png" alt="Add" />'.lADD_NEW.' '.
            $SectionSingular[$section].'</a>';
    }

    /**
     * Generate HTML for an E-mail link button
     *
     * @param $address string the e-mail address
     * @param $text string text extra text to add to the link
     * @return string
     */
    function emailButton($address, $text = '')
    {
        return '<a href="mailto:'.$address.'" title="E-mail '.$address.'">'.
            '<img src="images/button_email.png" alt="E-mail" />'.$text.'</a>';
    }

    /**
     * Generate HTML for an X icon
     *
     * The X icon is used when features aren't available, such as an e-mail link
     *
     * @return string
     */
    function xButton()
    {
        return '<img src="images/button_x.png" alt="N/A" />';
    }
?>