<?php
/**
 * Table Definition for Computers
 */
require_once 'DB/DataObject.php';

class DO_Computers extends DB_DataObject
{
    ###START_AUTOCODE
    /* the code below is auto generated do not remove the above tag */

    var $__table = 'Computers';                       // table name
    var $ComputerID;                      // int(10)  not_null primary_key unsigned auto_increment
    var $Vendor;                          // int(11)  unsigned
    var $Model;                           // string(50)
    var $Serial;                          // string(50)
    var $Location;                        // string(50)
    var $Campus;                          // int(11)  unsigned
    var $Department;                      // int(11)  unsigned
    var $Employee;                        // int(11)  unsigned
    var $ManufacturedDate;                // date(10)
    var $Warranty;                        // string(75)
    var $Laptop;                          // int(1)
    var $OperatingSystem;                 // int(11)  unsigned
    var $CPU;                             // string(50)
    var $RAM;                             // int(11)  unsigned
    var $Role;                            // int(11)  unsigned
    var $FQDN;                            // string(255)
    var $IPAddress;                       // string(15)
    var $Workgroup;                       // string(50)
    var $Notes;                           // blob(16777215)  blob
    var $Flag;                            // int(1)  not_null multiple_key unsigned

    /* ZE2 compatibility trick*/
    function __clone() { return $this;}

    /* Static get */
    function staticGet($k,$v=NULL) { return DB_DataObject::staticGet('DO_Computers',$k,$v); }

    /* the code above is auto generated do not remove the tag below */
    ###END_AUTOCODE

    function toString() {
        $ret = trim(@$this->Employee_Display.' - '.@$this->Vendor_Display.' '.@$this->Model);
        if ($this->Flag == fDELETED)
            $ret = '<span style="color: red;">['.$ret.']</span>';

        return $ret;
    }

    function delete($useWhere = FALSE) {
        if (isset($_SESSION['keepHistorical']) && $_SESSION['keepHistorical']==false) {
            parent::delete($useWhere);
        } else {
            $this->find();
            while($this->fetch()){
                $this->Flag = fDELETED;
                $this->update();
            } // while
        }
    }

    function table() {
        return array_merge(parent::table(), array('Vendor_Display' => DB_DATAOBJECT_STR, 'Employee_Display' => DB_DATAOBJECT_STR));
    }

    function find($n = false) {
        $tempDO = DB_DataObject::factory('Vendors');
        parent::joinAdd($tempDO,'LEFT');
        parent::selectAdd("Vendors.Company AS Vendor_Display");

        $tempDO = DB_DataObject::factory('Employees');
        parent::joinAdd($tempDO,'LEFT');
        parent::selectAdd('CONCAT(Employees.LastName,\', \',Employees.FirstName) AS Employee_Display');

        parent::find($n);
    }

    function insert() {
        if (isset($this->Vendor_Display))
            unset($this->Vendor_Display);
        if (isset($this->Employee_Display))
            unset($this->Employee_Display);

        parent::insert();
    }

    function update($do = false) {
        if (isset($this->Vendor_Display))
            unset($this->Vendor_Display);
        if (isset($this->Employee_Display))
            unset($this->Employee_Display);

        if (is_object($do)) {
            if (isset($do->Vendor_Display))
                unset($do->Vendor_Display);
            if (isset($do->Employee_Display))
                unset($do->Employee_Display);
        }

        parent::update($do);
    }
}
?>
