<?php
/**
 * Table Definition for KnowledgeBase
 */
require_once 'DB/DataObject.php';

class DO_KnowledgeBase extends DB_DataObject
{
    ###START_AUTOCODE
    /* the code below is auto generated do not remove the above tag */

    var $__table = 'KnowledgeBase';                   // table name
    var $KBID;                            // int(10)  not_null primary_key unsigned auto_increment
    var $KBCategory;                      // int(10)  unsigned
    var $Keywords;                        // string(255)  multiple_key
    var $Title;                           // string(255)  
    var $Article;                         // blob(65535)  not_null blob
    var $Created;                         // datetime(19)  not_null
    var $Updated;                         // datetime(19)  not_null
    var $Flag;                            // int(4)  not_null multiple_key

    /* ZE2 compatibility trick*/
    function __clone() { return $this;}

    /* Static get */
    function staticGet($k,$v=NULL) { return DB_DataObject::staticGet('DO_KnowledgeBase',$k,$v); }

    /* the code above is auto generated do not remove the tag below */
    ###END_AUTOCODE
    var $fieldsToRender = array('Description');
    var $hidePrimaryKey = TRUE;
    var $userEditableFields = array('Description');

    function toString() {
        $ret = @$this->Title;
        if ($this->Flag == fDELETED)
            $ret = '<span style="color: red;">['.$ret.']</span>';

        return $ret;
    }

    function delete($useWhere = FALSE) {
        if (isset($_SESSION['keepHistorical']) && $_SESSION['keepHistorical']==false) {
            parent::delete($useWhere);
        } else {
            $this->find();
            while($this->fetch()){
                $this->Flag = fDELETED;
                $this->update();
            } // while
        }
    }

    function table() {
        return array_merge(parent::table(), array('Category_Display' => DB_DATAOBJECT_STR));
    }

    function find($n = false) {
        $tempDO = DB_DataObject::factory('KBCategories');
        parent::joinAdd($tempDO,'LEFT');
        parent::selectAdd("KBCategories.Description AS Category_Display");

        parent::find($n);
    }

    function insert() {
        if (isset($this->Category_Display))
            unset($this->Category_Display);

        parent::insert();
    }

    function update($do = false) {
        if (isset($this->Category_Display))
            unset($this->Category_Display);

        if (is_object($do)) {
            if (isset($do->Category_Display))
                unset($do->Category_Display);
        }

        parent::update($do);
    }
}
?>