<?php
/**
 * Table Definition for News
 */
require_once 'DB/DataObject.php';

class DO_News extends DB_DataObject 
{
    ###START_AUTOCODE
    /* the code below is auto generated do not remove the above tag */

    var $__table = 'News';                            // table name
    var $NewsID;                          // int(10)  not_null primary_key unsigned auto_increment
    var $CreationStamp;                   // datetime(19)  not_null
    var $EmployeeID;                      // int(10)  not_null unsigned
    var $Title;                           // string(30)  not_null
    var $Text;                            // blob(65535)  not_null blob
    var $ExpirationTime;                  // datetime(19)  
    var $Flag;                            // int(4)  not_null multiple_key

    /* ZE2 compatibility trick*/
    function __clone() { return $this;}

    /* Static get */
    function staticGet($k,$v=NULL) { return DB_DataObject::staticGet('DO_News',$k,$v); }

    /* the code above is auto generated do not remove the tag below */
    ###END_AUTOCODE

    function find($n = false) {
        $tempDO = DB_DataObject::factory('Employees');
        parent::joinAdd($tempDO,'LEFT');
        parent::selectAdd('CONCAT(Employees.FirstName,\' \',Employees.LastName) AS Employee_Display');

        parent::find($n);
    }

    function insert() {
        if (isset($this->Employee_Display))
            unset($this->Employee_Display);
        
        parent::insert();
    }
    
    function update($do = false) {
        if (isset($this->Employee_Display))
            unset($this->Employee_Display);
        
        if (is_object($do)) {
            if (isset($do->Employee_Display))
                unset($do->Employee_Display);
        }
        
        parent::update($do);
    }
    
    function toString() {
        $ret = @$this->Title;
        if ($this->Flag == fDELETED)
            $ret = '<span style="color: red;">['.$ret.']</span>';
        
        return $ret;
    }
    
    function delete($useWhere = FALSE) {
        if (isset($_SESSION['keepHistorical']) && $_SESSION['keepHistorical']==false) {
            parent::delete($useWhere);
        } else {
            $this->find();
            while($this->fetch()){
                $this->Flag = fDELETED;
                $this->update();
            } // while
        }
    }
}
?>