<?php
/**
 * Table Definition for Peripherals
 */
require_once 'DB/DataObject.php';

class DO_Peripherals extends DB_DataObject 
{
    ###START_AUTOCODE
    /* the code below is auto generated do not remove the above tag */

    var $__table = 'Peripherals';                     // table name
    var $PeripheralID;                    // int(10)  not_null primary_key unsigned auto_increment
    var $Vendor;                          // int(11)  unsigned
    var $Model;                           // string(50)  
    var $Serial;                          // string(50)  
    var $Location;                        // string(50)  
    var $Campus;                          // int(11)  unsigned
    var $Department;                      // int(11)  unsigned
    var $Employee;                        // int(11)  unsigned
    var $ManufactureDate;                 // date(10)  
    var $Warranty;                        // string(75)  
    var $Computer;                        // int(11)  unsigned
    var $FQDN;                            // string(255)  
    var $IPAddress;                       // string(15)  
    var $PeripheralType;                  // int(10)  not_null
    var $Flag;                            // int(1)  not_null multiple_key unsigned
    var $Notes;                           // blob(16777215)  blob

    /* ZE2 compatibility trick*/
    function __clone() { return $this;}

    /* Static get */
    function staticGet($k,$v=NULL) { return DB_DataObject::staticGet('DO_Peripherals',$k,$v); }

    /* the code above is auto generated do not remove the tag below */
    ###END_AUTOCODE

    function toString() {
        $ret = trim(@$this->Vendor_Display . ' - ' . @$this->Model);
        if($this->Flag == fDELETED)
            $ret = '<span style="color: red;">[' . $ret . ']</span>';
        return $ret;
    }

    function delete($useWhere = FALSE) {
        if(isset($_SESSION['keepHistorical']) && $_SESSION['keepHistorical']==false) {
            parent::delete($useWhere);
        } else {
            $this->find();
            while($this->fetch()) {
                $this->Flag = fDELETED;
                $this->update();
            }
        }
    }
}
