<?php
/**
 * Table Definition for Policies
 */
require_once 'DB/DataObject.php';

class DO_Policies extends DB_DataObject
{
    ###START_AUTOCODE
    /* the code below is auto generated do not remove the above tag */

    var $__table = 'Policies';                        // table name
    var $PolicyID;                        // int(10)  not_null primary_key unsigned auto_increment
    var $Flag;                            // int(1)  not_null multiple_key unsigned
    var $Category;                        // int(10)  unsigned
    var $Title;                           // string(255)  

    /* ZE2 compatibility trick*/
    function __clone() { return $this;}

    /* Static get */
    function staticGet($k,$v=NULL) { return DB_DataObject::staticGet('DO_Policies',$k,$v); }

    /* the code above is auto generated do not remove the tag below */
    ###END_AUTOCODE

    function toString()
    {
        $ret = @$this->Title;
        if ($this->Flag == fDELETED)
            $ret = '<span style="color: red;">['.$ret.']</span>';

        return $ret;
    }

    function delete($useWhere = FALSE)
    {
        if (isset($_SESSION['keepHistorical']) && $_SESSION['keepHistorical']==false) {
            parent::delete($useWhere);
        } else {
            $this->find();
            while($this->fetch()){
                $this->Flag = fDELETED;
                $this->update();
            } // while
        }
    }

    function table()
    {
        return array_merge(parent::table(), array('Category_Display' => DB_DATAOBJECT_STR));
    }

    function find($n = false)
    {
        parent::joinAdd(DB_DataObject::factory('PolicyCategories'));
        parent::selectAdd("PolicyCategories.Description AS Category_Display");

        parent::find($n);
    }

    function insert()
    {
        if (isset($this->Category_Display))
            unset($this->Category_Display);

        parent::insert();
    }

    function update($do = false)
    {
        if (isset($this->Category_Display))
            unset($this->Category_Display);

        if (is_object($do) && isset($do->Category_Display))
            unset($do->Category_Display);

        parent::update($do);
    }
}
?>
