<?php
/**
 * Table Definition for Printers
 */
require_once 'DB/DataObject.php';

class DO_Printers extends DB_DataObject
{
    ###START_AUTOCODE
    /* the code below is auto generated do not remove the above tag */

    var $__table = 'Printers';                        // table name
    var $PrinterID;                       // int(10)  not_null primary_key unsigned auto_increment
    var $Vendor;                          // int(10)  unsigned
    var $Model;                           // string(100)  
    var $ModelNumber;                     // string(100)  
    var $SerialNumber;                    // string(25)  
    var $PurchasedDate;                   // date(10)  
    var $Computer;                        // int(10)  unsigned
    var $Department;                      // int(10)  unsigned
    var $CostPerPage;                     // real(6)  
    var $NetworkReady;                    // string(100)  not_null
    var $Multifunction;                   // int(4)  not_null
    var $PrinterType;                     // int(11)  not_null
    var $Notes;                           // string(255)  
    var $Flag;                            // int(4)  not_null multiple_key

    /* ZE2 compatibility trick*/
    function __clone() { return $this;}

    /* Static get */
    function staticGet($k,$v=NULL) { return DB_DataObject::staticGet('DO_Printers',$k,$v); }

    /* the code above is auto generated do not remove the tag below */
    ###END_AUTOCODE
    /**
     * return a string representation of this Printer object
     *
     * Returns a string by concatenating the Model & Model Number plus enclosing
     * the entire string in []'s if it's deleted.
     *
     * @return string representation of this Printer object
     */
    function toString()
    {
        $ret = trim(@$this->Model.' '.@$this->ModelNumber);
        if ($this->Flag == fDELETED)
            $ret = '<span style="color: red;">['.$ret.']</span>';

        return $ret;
    }

    function delete($useWhere = FALSE)
    {
        if (isset($_SESSION['keepHistorical']) && $_SESSION['keepHistorical']==false) {
            parent::delete($useWhere);
        } else {
            $this->find();
            while($this->fetch()){
                $this->Flag = fDELETED;
                $this->update();
            } // while
        }
    }
}
?>