<?php
    // Temporary work-around for Pear Bug #2356: Call time pass by ref. error
    ini_set('allow_call_time_pass_reference', 1);
    // Temporary work around for DB_DataObject 1.7.5 & PHP 4.3.10
    define('DB_DATAOBJECT_NO_OVERLOAD',true);

    // Start session and save it for 8 days
    session_name('OpenITSessionID');
    session_cache_expire(691200);
    session_set_cookie_params(691200);
    session_start();

    require_once 'DB.php';
    require_once 'DB/DataObject.php';
    require_once 'HTML/Table.php';

    // Define version number
    define('VERSION', '2.0-beta1');
    define('FULLTITLE','OpenIT '.VERSION);

    // Replace the following constant with iso_datetime()
    define('MYSQL_DATE','%Y-%m-%d %T');

    // Thanks to "burden123 at rogers dot com" for this handy function
    // See: http://www.php.net/manual/en/function.date.php
    function iso_datetime($time = null)
    {
        if (empty($time)) {
            $time = time();
        }

        $tzd = date('O',$time);
        $tzd = substr(chunk_split($tzd, 3, ':'),0,6);
        $date = date('Y-m-d\TH:i:s', $time) . $tzd;
        return $date;
    }

    // Define row status flags
    define('fNORMAL',0);
    define('fDELETED',1);
    define('fUNPUBLISHED',2);

    // Define [s]ection constants
    define('sCOMPUTERS', 'Computers');
    define('sPRINTERS', 'Printers');
    define('sPERIPHERALS', 'Peripherals');
    define('sSOFTWARE', 'Software');
    define('sEMPLOYEES', 'Employees');
    define('sREPORTS', 'Reports');
    define('sSUPPORT', 'Support');
    define('sSUPPORTLOG', 'SupportLog');
    define('sKB', 'KnowledgeBase');
    define('sGROUPS', 'Groups');
    define('sLOOKUPS','Lookups');
    define('sNEWS','News');
    define('sPOLICIES','Policies');
    define('sOUTOFOFFICE','OutOfOffice');

    // Database Related Constants
    define('NEWID', -1);
    define('GUESTS_GROUPID', 1);

    // Includes database, settings, and language loading script
    require_once('inc/settings.php');

    // Include authentication/permissions handling script
    require_once('inc/auth.php');

    // Define section -> page table
    $SectionNames = array(sCOMPUTERS=>lCOMPUTERS, sEMPLOYEES=>lEMPLOYEES,
        sGROUPS=>lGROUPS, sKB=>lKB, sLOOKUPS=>lLOOKUPS, sNEWS=>lNEWS,
        sPOLICIES=>lPOLICIES, sPRINTERS=>lPRINTERS, sPERIPHERALS=>lPERIPHERALS,
        sSOFTWARE=>lSOFTWARE, sSUPPORT=>lSUPPORT, sSUPPORTLOG=>lSUPPORTLOG,
        sOUTOFOFFICE=>lOUTOFOFFICE,sREPORTS=>lREPORTS);

    // Define section -> singular name
    $SectionSingular = array(sCOMPUTERS=>lCOMPUTER, sEMPLOYEES=>lEMPLOYEE,
        sGROUPS=>lGROUP, sKB=>lKBARTICLE, sLOOKUPS=>lLOOKUP, sNEWS=>lNEWS,
        sPOLICIES=>lPOLICY, sPRINTERS=>lPRINTER, sPERIPHERALS=>lPERIPHERAL,
        sSOFTWARE=>lSOFTWARE, sSUPPORT=>lSUPPORTISSUE,
        sSUPPORTLOG=>lSUPPORTLOGITEM, sOUTOFOFFICE=>lOUTOFOFFICE,
        sREPORTS=>lREPORT);

    // Include other common files
    require_once('inc/buttons.php');
    require_once('inc/debug.php');
    require_once('inc/notification.php');

    /**
     * Simple redirect browsers function
     *
     * A simple function to redirect browsers via JavaScript.  This function
     * merely prints some predefined DHTML, but more intelligence could be
     * added.
     *
     * @param string $link The URL to redirect the user's browser to
     * @return string DHTML which causes the user's browser to redirect
     * @since Version 2.0
     */
    // Redirection HTML Wrapper
    function my_redirect($link)
    {
        return sprintf(lREDIRECT_HTML, $link, $link);
    }
?>