<?php
    $startTime = getMicroTime();

    PEAR::setErrorHandling(PEAR_ERROR_DIE);
    DB_DataObject::debugLevel(0);

    function getMicroTime()
    {
        list($usec, $sec) = explode(" ", microtime());
        return ((float)$usec + (float)$sec);
    }

    function outputDebugInfo()
    {
        global $settings;

        /* Some linux vendors (Gentoo is an example) disable-memory-limit
         * by default in mod_php installs, so we need to enable a way
         * to disable its usage (debug = false in settings.ini) b/c it
         * will stop processing when it hits the memory_get_usage() below */
        if(isset($settings['Debug']) && $settings['Debug'])
            echo '<p class="footer">'.
                'Script included '.count(get_included_files()).
                ' files.<br />'."\n".
                'Script used '.@round((memory_get_usage() / 1024), 1).
                ' kilobytes of memory.<br />'."\n".
                execTime().
                '</p>';
    }

    function execTime()
    {
        global $startTime;

        $endTime = getmicrotime();
        $total_time = $endTime - $startTime;
        return ''.
            "Script executed in $total_time seconds.<br />\n";
    }
?>