<?php
    require_once('DB.php');

    $_SESSION['settings'] = parse_ini_file('inc/settings.ini', true);

    $settings = &$_SESSION['settings'];

    // Automagically set annoying DB_DataObject Settins
    if(empty($settings['DB_DataObject']['schema_location']))
        $settings['DB_DataObject']['schema_location'] = dirname(__FILE__).'/schema';
    if(empty($settings['DB_DataObject']['class_location']))
        $settings['DB_DataObject']['class_location'] = dirname(__FILE__).'/classes';

    // These DB_DataObject Settings should be constant
    $settings['DB_DataObject']['require_prefix'] = 'inc/classes';
    $settings['DB_DataObject']['class_prefix'] = 'DO_';

    // ID Formatting Options
    if(empty($settings['PeripheralIDFormat']))
        $settings['PeripheralIDFormat'] = '%d';
    if(empty($settings['ComputerIDFormat']))
        $settings['ComputerIDFormat'] = '%d';

    // Connect to Database using DataObject's DSN
    $db =& DB::connect($settings['DB_DataObject']['database']);
    $db->setOption('seqname_format', 'seq_%s');

    // Set default fetch mode
    $db->setFetchMode(DB_FETCHMODE_ASSOC);

    // Initialize PEAR::DataObjects & related
    $option=&PEAR::getStaticProperty('DB_DataObject','options');
    $option=$settings['DB_DataObject'];

    // Load Language settings
    if (!empty($_SESSION['EmployeeID']) && $_SESSION['EmployeeID'] > 0) {
        $Employee = DB_DataObject::staticGet('DO_Employees', $_SESSION['EmployeeID']);
        if (is_string($Employee->Language) && file_exists('inc/lang/'.$Employee->Language.'.php')) {
            // Use user-specified language
            $_SESSION['Language'] = $Employee->Language;
        }
    }

    if (empty($_SESSION['Language'])) {
        // Use default language specified in settings.ini
        $_SESSION['Language'] = $settings['Language'];
    }

    // Load language file -- CANNOT USE LANGUAGE CONSTANTS BEFORE THIS POINT --
    require_once('inc/lang/'.$_SESSION['Language'].'.php');

    /**
     * Simple wrapper around an ecryption algorithm
     *
     * A simple wrapper around a 1-way hash algorithm, sha1 by default, which is
     * used to securely store passwords in the database.
     *
     * @param string $text A string, usually a password, to be encrypted
     * @return string Encrypted text string (sha1 hashed by default)
     * @since Version 2.0
     */
    // Encryption Wrapper
    function my_crypt($text)
    {
        return sha1($text);
    }
?>