<?php
    require_once('inc/common.php');

    // Set these to their default values
    $noPermissions = false;
    $showFooter = true;

    if (isset($_GET['ID']))
       $ID = $_GET['ID'];
    if (isset($_GET['Category']))
       $Category = $_GET['Category'];
    // LIST
    if (isset($_GET['List'])) {
        $table = $_GET['List'];

        if (!isset($SectionNames[$table])) {
            $section = 'Error';
            require_once('inc/header.php');

            echo '<p>There has been a non-critical error.  You may continue to use '.
                FULLTITLE.' but please contact your system administrator.</p>';
        }
        elseif (ListPerm($table)) {
            $extraHeaders = '<script language="JavaScript1.2" src="js/highlight.js"'.
                ' type="text/javascript"></script>';
            $section = $SectionNames[$table];
            require_once('inc/common.list.php');
            $include = "modules/$table/list.php";
        }
        else {
            $noPermissions = true;
        }

    // SAVE
    } elseif (isset($_GET['Save'])) {
        $table = $_GET['Save'];
        if(EditPerm($table)) {
            $include = "modules/$table/save.php";
        }
        else {
            $noPermissions = true;
        }

     // EDIT
    } elseif (isset($_GET['Edit'])) {
        require_once 'HTML/QuickForm.php';
        $section = lEDITING;
        $table = $_GET['Edit'];

        // Hack to get Out of Office DHTML Calendar working
        if ($table == sOUTOFOFFICE) {
            require_once 'js/calendar/calendar.php';
            $jsCalendar = new DHTML_Calendar(dirname($_SERVER['PHP_SELF']).'/js/calendar/', 'en', 'calendar-win2k-2');
            $extraHeaders = $jsCalendar->get_load_files_code();
        }

        if (!is_numeric($ID)) {
            die('Invalid ID');
        }

        if (isset($_GET['View']))
            $showFrozen=true;
        else
            $showFrozen=false;

        if ($table == sSUPPORTLOG) {
            // Here's a little hack to get Support Log Items to work
            if (EditPerm(sSUPPORT)) {
                $include = 'modules/'.sSUPPORT.'/edit.supportlog.php';
            } else {
                $noPermissions = true;
            }
        } elseif (EditPerm($table)) {
            // Normal Editing Code Flow
            $include = "modules/$table/edit.php";
        } elseif ($table == sEMPLOYEES && $ID == $_SESSION['EmployeeID']) {
            $include = "modules/$table/edit.php";
        } else {
            $noPermissions = true;
        }

    // VIEW
    } elseif (isset($_GET['View'])) {
        $table = $_GET['View'];
        $section = lVIEW;

        if (ViewPerm($table)) {
            // They have permission, now determine what script to load

            if (file_exists("modules/$table/view.php")) {
                // Use special View script
                $include = "modules/$table/view.php";
            } else {
                // Use frozen edit form
                require_once "HTML/QuickForm.php";
                $include = "modules/$table/edit.php";
                $showFrozen = true;
            }

        } else {
            $noPermissions = true;
        }

    // REMOVE
    } elseif (isset($_GET['Remove'])) {
        $section = lCONFIRM_REMOVE;
        $table = $_GET['Remove'];

        if (RemvPerm($table)) {
            $include = "modules/$table/remove.php";
            if (!file_exists($include))
                $include="inc/common.remove.php";
        } else {
            $noPermissions = true;
        }

    // MINIVIEW
    } elseif (isset($_GET['MiniView'])) {
        $table = $_GET['MiniView'];
        if (ViewPerm($table)) {
            $include = "modules/$table/minview.php";
        } else {
            $noPermissions = true;
        }

    // EXPORT
    } elseif (isset($_GET['Export'])) {
        $table = $_GET['Export'];
        if (ViewPerm($table)) {
            require_once("modules/$table/export.php");
            $showFooter = false;
        } else {
            $noPermissions = true;
        }
    // HOME
    } else {
        $section = lHOME;
        $include = 'modules/News/miniview.php';
    }

    if ($noPermissions) {
        require_once('inc/header.php');
        outputNoPermission();
    }
    elseif (isset($include)) {
        require_once('inc/header.php');
        require_once($include);
    }

    if ($showFooter) {
        if ($settings['Debug']) {
            outputDebugInfo();
        }
        echo footer();
    }
?>