<?php
$do = DB_DataObject::factory('Computers');

$changeDO=DB_DataObject::factory('Changelog');
$changeDO->TableName='Computers';
$changeDO->UserIP=$_SERVER['REMOTE_ADDR'];
$changeDO->EmployeeID=$_SESSION['EmployeeID'];
$data=array();

if ($ID != NEWID) {
    // UPDATE
    $do->get($ID);

    if($do->count(true)<1) {
        die("No ".lCOMPUTER." with that ID");
    }

    $changeDO->Description=lEDITING.' '.lCOMPUTER." ($ID)";
    $changeDO->QueryType='UPDATE';
    $data=$do->toArray('computer_%s');

    $subDO = DB_DataObject::factory('Installations');
    $subDO->Computer=$ID;
    $subDO->find();
    while($subDO->fetch()){
        $data["software[{$subDO->Software}]"]=true;
        $data["softwareID_{$subDO->Software}"]=$subDO->ID;
    } // while

    if(!is_null($do->ManufacturedDate))
        $data['computer_ManufacturedDate'] = strtotime($do->ManufacturedDate);

} else {
    // INSERT
    $changeDO->Description=lADD_NEW.' '.lCOMPUTER;
    $changeDO->QueryType='INSERT';
    $data['computer_ComputerID']=NEWID;
    $data['computer_ManufacturedDate'] = time();
}

$osOptions = array(0=>'Unspecified');
$softwareGroup=array();

// Load Vendors
$tempDO = DB_DataObject::factory('Vendors');
$tempDO->orderBy('Company');
$tempDO->find();
$vendorOptions = array(0=>'Unspecified');
while($tempDO->fetch()){
    $vendorOptions[$tempDO->ID]=$tempDO->toString();
}

// Load Campuses
$tempDO = DB_DataObject::factory('Campuses');
$tempDO->orderBy('Description');
$tempDO->find();
$campusOptions=array(0=>'Unspecified');
while($tempDO->fetch()){
    $campusOptions[$tempDO->ID]=$tempDO->toString();
}

// Load Departments
$tempDO = DB_DataObject::factory('Departments');
$tempDO->orderBy('Description');
$tempDO->find();
$departmentOptions=array(0=>'Unspecified');
while($tempDO->fetch()){
    $departmentOptions[$tempDO->ID]=$tempDO->toString();
}

// Load Employees
$tempDO = DB_DataObject::factory('Employees');
$tempDO->orderBy('LastName, FirstName');
$tempDO->find();
$employeeOptions=array(0=>'Unspecified');
while($tempDO->fetch()){
    $employeeOptions[$tempDO->EmployeeID]=$tempDO->toString();
}

// Load Roles
$tempDO = DB_DataObject::factory('Role');
$tempDO->orderBy('Description');
$tempDO->find();
$roleOptions=array(0=>'Unspecified');
while($tempDO->fetch()){
    $roleOptions[$tempDO->ID]=$tempDO->toString();
}

// Start the actual form
$form = new HTML_QuickForm('Computer','POST', 'index.php?Edit=Computers&ID='.$ID);
$form_renderer = &$form->defaultRenderer();
$form_renderer->setGroupTemplate("<table>\n\t<tr>{content}\n</table>",'software');
$form_renderer->setGroupElementTemplate('<td>{element}</td>','software');

// Installable Software & OS lists
$tempDO = DB_DataObject::factory('Software');
$tempDO->selectAdd('Software.ID,CONCAT(Vendors.Company," ",Software.Title," ",Software.Version) AS Name');
$tempDO->joinAdd(DB_DataObject::factory('Vendors'), 'LEFT');
$tempDO->whereAdd('Software.Flag != 1');
$tempDO->orderBy('Name');
$tempDO->find();
while($tempDO->fetch()){
    if ($tempDO->isOS==1) {
        $osOptions[$tempDO->ID] = $tempDO->toValue('Name');
    } else {
        $form->addElement('hidden',"softwareID_{$tempDO->ID}",'-1');
        $softwareGroup[$tempDO->ID] =
            &HTML_QuickForm::createElement('checkbox', $tempDO->ID, null,$tempDO->toString('Name'));
    }
}
unset($tempDO);

if($ID == NEWID) {
    $form->addElement('header', null, lADD_NEW . ' ' . lCOMPUTER);
} elseif(isset($showFrozen) && $showFrozen) {
    $form->addElement('header', null, lVIEWING . ' ' . lCOMPUTER .
            ' (' . sprintf($settings['ComputerIDFormat'], $ID) . ')');
} else {
    $form->addElement('header', null, lEDITING . ' ' . lCOMPUTER .
            ' (' . sprintf($settings['ComputerIDFormat'], $ID) . ')');
}

$form->addElement('hidden', 'computer_ComputerID', $ID);
$form->addElement('select', 'computer_Vendor', 'Vendor:', $vendorOptions);
$form->addElement('text','computer_Model','Model:',array('size'=>50));
$form->addElement('checkbox','computer_Laptop','Laptop:','(Check if computer is a laptop)');
$form->addElement('text','computer_Serial','Serial Number:',array('size'=>30));
$form->addElement('text','computer_Location','Location:',array('size'=>30));
$form->addElement('select', 'computer_Campus', 'Campus:', $campusOptions);
$form->addElement('select', 'computer_Department', 'Department:', $departmentOptions);
$form->addElement('select', 'computer_Employee', 'Employee:', $employeeOptions);
$form->addElement('text','computer_Warranty','Warranty:',array('size'=>60));
$form->addElement('date','computer_ManufacturedDate','Manufactured On:',
                array('minYear' => '1990', 'maxYear' => date("Y", time()),
                        'language' => 'en', 'format' => 'M d, Y'));
$form->addElement('select', 'computer_OperatingSystem', 'Operating System:', $osOptions);
$form->addElement('text','computer_CPU','CPU:',array('size'=>30));
$form->addElement('text','computer_RAM','RAM (MB):',array('size'=>10));
$form->addElement('select', 'computer_Role', 'Role:', $roleOptions);
$form->addElement('text', 'computer_FQDN', lFQDN.':', array('size' => 50, 'maxlength' => 255));
$form->addElement('text','computer_IPAddress','IP Address:');
$form->addElement('text','computer_Workgroup','Workgroup:',array('colspan'=>2));

if (isset($softwareGroup) && count($softwareGroup) > 0) {
    $form->addGroup($softwareGroup, 'software', 'Installed Software:',
        array('',"</tr>\n\t<tr>"));
} else {
    $form->addElement('link','linkSoftware','Installed Software:',
        'index.php?Edit=Software&ID='.NEWID,'Add Software');
}

$form->addElement('textarea','computer_Notes','Notes:',array('rows' => 10, 'cols' => 45));

$form->setDefaults($data);

if ($showFrozen) {
    // Just VIEW the Computer
    $form->freeze();
    $form->display();
} else {
    // Save the computer
    if ($form->validate()) {
        $form->process('processForm', false);
        $changeDO->insert();
        echo my_redirect('index.php?List=Computers');
    } else {
        // Output the Edit Form
        $form->addElement('submit', null, 'Submit');
        $form->display();
    }
}
function processForm($values) {
    $do = DB_DataObject::factory('Computers');

    if ($values['computer_ComputerID']==NEWID) {
        unset($values['computer_ComputerID']);
    } else {
        $do->get($values['computer_ComputerID']);
        $ID = $do->ComputerID;
    }

    $ret = $do->setFrom($values,'computer_%s');

    if ($ret === true) {
        $softwareMatrix = array();

        $do->ManufacturedDate = sprintf("%4d-%02d-%02d",
                                    $values['computer_ManufacturedDate']['Y'],
                                    $values['computer_ManufacturedDate']['M'],
                                    $values['computer_ManufacturedDate']['d']);

        if (isset($values['computer_ComputerID'])) {
            // Do the UPDATE
            $do->update();

            foreach ($values as $key=>$value) {
                if (strstr($key,'softwareID_')!==false && $value>0) {
                    $softwareMatrix[substr($key,11)]=array('ID'=>$value,'checked'=>false);
                }
            }
        } else {
            // Do the INSERT
            $ID = $do->insert();
            // The previous statement does not always set the ID properly
            $ID = $do->ComputerID;
        }
        if ($ID > 0) {
            if (isset($values['software'])) {
                foreach ($values['software'] as $key=>$value) {
                    if (!isset($softwareMatrix["$key"]))
                        $softwareMatrix["$key"]['ID'] = -1;

                    $softwareMatrix["$key"]['checked'] = true;
                }
            }
            $subDO = DB_DataObject::factory('Installations');
            foreach ($softwareMatrix as $rowID=>$info) {
                if ($info['checked'] && $info['ID']<=0) {
                    // insert
                    $subDO->ID = null;
                    $subDO->Software = $rowID;
                    $subDO->Computer = $ID;
                    $subDO->SerialNumber = null;
                    $subDO->DateInstalled = strftime(MYSQL_DATE);
                    $subDO->DateUpdated = null;
                    $subDO->insert();

                } elseif (!$info['checked'] && $info['ID']>0) {
                    //delete
                    $subDO->get($info['ID']);
                    $subDO->delete();
                }
            }
        } else {
            die("<p>Computer ID does not appear to be set correctly,.</p>");
        }
    } else {
        die('<p><b>Computer edit form errors:</b> '  . implode(', ', $ret).'</p>');
    }
}
?>
