<?php
    $do = DB_DataObject::factory('Computers');
    $RoleDO = DB_DataObject::factory('Role');
    $do->selectAdd();
    $do->joinAdd($RoleDO,'LEFT');
    $do->joinAdd(DB_DataObject::factory('Campuses'), 'LEFT');

    //$do->selectAdd('Computers.ComputerID,Computers.ManufacturedDate,Computers.Model');
    $do->selectAdd('Computers.ComputerID,Computers.FQDN,' .
        'CONCAT(Vendors.Company," ",Computers.Model) AS Name,' .
        'Campuses.Description AS Campuses_Display,Computers.Location AS Computers_Location,' .
        'Role.Description AS Role_Display');

    // START -- SORT
    // Set OrderBy Column and Sort Order

    $sort = (isset($_GET['Sort']) && $_GET['Sort'] == 'desc') ? 'DESC' : 'ASC';
    $orderBy = "ComputerID $sort";

    if (isset($_GET['Order'])) {
        switch ($_GET['Order']) {
            case 'Name':
                $orderBy = "Name $sort,$orderBy";
                break;
            case 'FQDN':
                $orderBy = "Computers.FQDN $sort,$orderBy";
                break;
            case 'Locale':
                $orderBy = "Campuses_Display $sort,Computers_Location $sort,$orderBy";
                break;
            case 'Role':
                $OrderBy = "Role_Display $sort,$orderBy";
                break;
        }
    }
    $do->orderBy($orderBy);
    // END -- SORT
    $do->whereAdd('Computers.Flag != '.fDELETED);

    // START -- FILTER
    $Filters = array();
    if (!empty($_GET['Filter']) && is_array($_GET['Filter'])) {
        $Filters = $_GET['Filter'];

        $FilterSQL = '';
        foreach($Filters as $RoleID) {
            $FilterSQL .= "Computers.Role = $RoleID OR ";
        }
        // Remove the dangling OR
        $FilterSQL = substr($FilterSQL, 0, -4);

        // Add the Filter to the DataObject's WHERE clause with an AND operator
        $do->whereAdd('('.$FilterSQL.')', 'AND');
    }

    // Get list of Computers from Table
    $do->find();

    // Add Filter options
    $FilterTable =& new HTML_Table(array('cellpadding'=>'0', 'cellspacing'=>'0'));
    $FilterTable->setAutoGrow(true);
    $FilterTable->addRow(array('Select Filters'), null, 'TH');
    $RoleDO->whereAdd('Flag != '.fDELETED);
    $RoleCount = $RoleDO->find();
    $index = 1;
    while($RoleDO->fetch()) {
        $checked = '';

        if (in_array($RoleDO->ID, $Filters)) {
            $checked = 'checked="checked"';
        }

        $NewRow = array(
            '<label><input type="checkbox" name="Filter[]" '.
            'value="'.$RoleDO->ID.'" '.$checked.' />'.
            $RoleDO->Description.'</label>');

        if ($RoleCount > $index++) {
            // 2 or more rows left, so output two filters on this line
            $RoleDO->fetch();

            $checked = '';

            if (in_array($RoleDO->ID, $Filters)) {
                $checked = 'checked="checked"';
            }

            $NewRow[] = '<label><input type="checkbox" name="Filter[]" '.
                'value="'.$RoleDO->ID.'" '.$checked.' />'.
                $RoleDO->Description.'</label>';
        }

        $FilterTable->addRow($NewRow);
    }
    echo '
    <form method="GET" action="index.php">
        <input type="hidden" name="List" value="Computers" />
        '.$FilterTable->toHTML().'
        <input type="submit" value="Filter" />
    </form>';
    // END -- FILTER

    // START -- LIST
    $table =& new HTML_Table(array('cellpadding'=>'0', 'cellspacing'=>'0'));
    $table->setAutoGrow(true);

    switch(Permission(sCOMPUTERS)) {
        case pREMV:
            $newRow[] = '';
        case pEDIT:
            $newRow[] = '';
        case pVIEW:
            $newRow[] = '';
            // if(ViewPerm(sSUPPORT))
                // $newRow[] = '';  // DOES NOT WORK
        case pLIST:
            $newRow[] = makeSortHeader('ID', 'ComputerID');
            $newRow[] = makeSortHeader(lMODEL, 'Name');
            $newRow[] = makeSortHeader(lFQDN, 'FQDN');
            $newRow[] = makeSortHeader(lLOCATION, 'Locale');
            $newRow[] = makeSortHeader(lROLE, 'Role');
    }
    $table->addRow($newRow, null, 'TH');

    while($do->fetch()){
        $newRow = array();

        switch(Permission(sCOMPUTERS)) {
            case pREMV:
                $newRow[] = RemoveButton(sCOMPUTERS, $do->ComputerID);
            case pEDIT:
                $newRow[] = EditButton(sCOMPUTERS, $do->ComputerID);
            case pVIEW:
                $newRow[] = ViewButton(sCOMPUTERS, $do->ComputerID);
                //if(ViewPerm(sSUPPORT)) {
                //    $newRow[] = '<a href="view.php?View=Support&Computer:'.$do->ComputerID.
                //        '" title="New '.lSUPPORTISSUE.'">'.
                //        '<img src="images/button_support.png" alt="New '.lSUPPORTISSUE.'" /></a>';
                //}
        }

        $newRow[] = sprintf($settings['ComputerIDFormat'], $do->ComputerID);
        $newRow[] = $do->toValue('Name');
        $newRow[] = $do->FQDN;
        $newRow[] = $do->toValue('Campuses_Display') . ' ' . $do->toValue('Computers_Location');
        $newRow[] = $do->toValue('Role_Display');

        $newRowID = $table->addRow($newRow);

        $rowAttr = array(
            'id'=>'row'.$do->ComputerID,
            'onMouseOver'=>"javascript:setColor(".$do->ComputerID.",'".$settings['bgColorHover']."')",
            'onMouseOut'=>"javascript:origColor(".$do->ComputerID.")");

        if(($newRowID%2) == 0)
            $rowAttr['class'] ='even';
        else
            $rowAttr['class'] = 'odd';

        $table->setRowAttributes($newRowID, $rowAttr, true);
    }

    if(EditPerm(sCOMPUTERS))
        echo AddNewButton(sCOMPUTERS);

    echo $table->toHTML();
?>