<?php
// Prepare the Changelog
$changeDO=DB_DataObject::factory('Changelog');
$changeDO->TableName='Computers';
$changeDO->UserIP=$_SERVER['REMOTE_ADDR'];
$changeDO->EmployeeID=$_SESSION['EmployeeID'];

$EmployeeDO = DB_DataObject::factory('Employees');
$ExistingData = array();

// UPDATE
if ($ID != NEWID) {
    // Set Changelog details
    $changeDO->Description = lEDITING.' '.lCOMPUTER.' '.$ID;
    $changeDO->QueryType = 'UPDATE';

    // Load Employee
    $EmployeeDO->get($ID);
    $ExistingData = $EmployeeDO->toArray('employee_%s');

} else {
    // INSERT

    // Set Changelog details
    $changeDO->Description = lADD_NEW.' '.lEMPLOYEE;
    $changeDO->QueryType = 'INSERT';

}

// Start Form
$form = new HTML_QuickForm('Employee', 'POST', 'index.php?Edit=Employees&ID='.$ID);
$form->addElement('hidden', 'employee_EmployeeID', $ID);
$form->addElement('header', null, (($ID==NEWID)?lADD_NEW:lEDITING).' '.lEMPLOYEE);
$form->addElement('checkbox', 'employee_Contractor', 'Is a Contractor?');
$form->addElement('checkbox', 'employee_ITTechnician', 'Is an IT Technician?');
$form->addElement('text', 'employee_FirstName', lFIRST_NAME.':');
$form->addElement('text', 'employee_LastName', lLAST_NAME.':');
$form->addElement('text', 'employee_MiddleInitial', 'Middle Initial'.':');

if (EditPerm(sGROUPS)) {
    // Allow editing of group
    $GroupDO = DB_DataObject::factory('Groups');
    $GroupDO->whereAdd('Flag = '.fNORMAL);
    $GroupDO->find();
    $Groups = array();
    while($GroupDO->fetch()) {
        $Groups[$GroupDO->GroupID] = $GroupDO->Name;
    }
    $form->addElement('select', 'employee_GroupID', lGROUP.':', $Groups);
}

// Password
if (EditPerm(sGROUPS) || $_SESSION['EmployeeID'] == $ID) {
    // Allow changing of password
    $form->addElement('text', 'employee_ClearPassword', lPASSWORD.':');

    // Allow them to keep their old password
    $form->addElement('checkbox', 'KeepPassword', 'Keep old '.lPASSWORD.'?',
        null, array('checked'=>'1'));
}

// Load Departments
$DepartmentDO = DB_DataObject::factory('Departments');
$DepartmentDO->orderBy('Description');
$DepartmentDO->whereAdd('Flag = '.fNORMAL);
$DepartmentDO->find();
$Departments = array(0=>'Unspecified');
while($DepartmentDO->fetch()){
    $Departments[$DepartmentDO->ID] = $DepartmentDO->toString();
}
$form->addElement('select', 'employee_Department', lDEPT.':', $Departments);

// Load Campuses
$CampusDO = DB_DataObject::factory('Campuses');
$CampusDO->whereAdd('Flag = '.fNORMAL);
$CampusDO->orderBy('Description');
$CampusDO->find();
$Campuses = array(0=>'Unspecified');
while($CampusDO->fetch()) {
    $Campuses[$CampusDO->ID] = $CampusDO->toString();
}
$form->addElement('select', 'employee_Campus', lCAMPUS.':', $Campuses);

$form->addElement('text', 'employee_HomePhone', 'Home Phone:');
$form->addElement('text', 'employee_WorkPhone', lWORK_PHONE.':');
$form->addElement('text', 'employee_MobilePhone', 'Mobile Phone:');
$form->addElement('text', 'employee_Fax', 'Fax Number:');
$form->addElement('text', 'employee_EmailAddress', 'E-mail:', array('size'=>35));
$form->addElement('text', 'employee_JabberAccount', 'Jabber Account:', array('size'=>35));

// Notifications
$NotificationMethods = array('none'=>'None', 'email'=>'Email', 'jabber'=>'Jabber');
$form->addElement('select', 'employee_PreferredNotification',
    'Preferred Notification:', $NotificationMethods);

// Home Address Information
$form->addElement('text', 'employee_HomeStreetAddress', 'Home Street Address:');
$form->addElement('text', 'employee_HomePOBox', 'Home PO Box:');
$form->addElement('text', 'employee_HomeCity', 'Home City:');
$form->addElement('text', 'employee_HomeState', 'Home State:');
$form->addElement('text', 'employee_HomeZip', 'Home Zip:');

// Languages
$Languages = array(
    'en-US' => 'English',
    'es-ES' => 'Español',
    'ct-CT' => 'Catalan',
    'de-DE' => 'Deutsch',
    'nl-NL' => 'Dutch',
    'it-IT' => 'Italian',
    'pl-PL' => 'Polish',
    'pt-BR' => 'Português (Brazil)'
);
$form->addElement('select', 'employee_Language', lLANGUAGE.':', $Languages);

$form->addElement('textarea', 'employee_Notes', lNOTES.':',
    array('rows'=>8, 'cols'=>50));

$form->setDefaults($ExistingData);

if ($showFrozen) {
    // Just VIEW the Employee

    $form->freeze();
    $form->display();

} else {

    if ($form->validate()) {
        // Save Form

        $form->process('processForm', false);
        $changeDO->insert();
        echo my_redirect('index.php?List=Employees');
    } else {
        // Output the Edit Form

        $form->addElement('submit', null, lSUBMIT);
        $form->display();
    }
}

function processForm($values)
{
    $do = DB_DataObject::factory('Employees');

    if ($values['employee_EmployeeID'] == NEWID) {
        // INSERT
        // Don't let the ID be set if we're inserting
        unset($values['employee_EmployeeID']);

        // Default the password to be blank
        $do->Password = my_crypt(null);
    } else {
        // UPDATE
        $do->get($values['employee_EmployeeID']);
        $ID = $do->EmployeeID;

        // Default the password to the previous password
        $values['employee_Password'] = $do->Password;
    }

    if ($values['employee_Campus'] == 0)
        $values['employee_Campus'] = null;

    if ($values['employee_Department'] == 0)
        $values['employee_Department'] = null;

    // Encrypt Password appropriately
    if (    (EditPerm(sGROUPS) || $_SESSION['EmployeeID'] == $ID)
            && !isset($values['KeepPassword'])) {
        $values['employee_Password'] = my_crypt($values['employee_ClearPassword']);
    }

    if ($do->setFrom($values, 'employee_%s')) {
        if (isset($values['employee_EmployeeID'])) {
            // UPDATE
            $do->update();
        } else {
            // INSERT
            $do->insert();
        }

    } else {
        die('<p>Could not save employee.</p>');
    }
}

?>