<?php
    require_once('inc/common.php');

    $do = DB_DataObject::factory('News');
    $depts = DB_DataObject::factory('News_Departments');
    $dept = DB_DataObject::factory('Departments');
    $depts->joinAdd($dept,'LEFT');
    $do->joinAdd($depts,'LEFT');
    $do->selectAdd();
    $do->selectAdd('News.*');
    $do->selectAs(array('Description'),'dl_%s','Departments');
    $do->orderBy('NewsID DESC, ExpirationTime');
    $do->whereAdd('(ExpirationTime IS NULL OR ExpirationTime > CAST(\''.strftime('%Y-%m-%d %T').'\' AS DATETIME))');
    $do->whereAdd('News.Flag != '.fDELETED);
    if (isset($_SESSION['Department']))
        $do->whereAdd('(News_Departments.NewsID IS NULL OR News_Departments.DepartmentID='.$_SESSION['Department'].')');
    else
        $do->whereAdd('(News_Departments.NewsID IS NULL)');

    $do->groupBy('News.NewsID');

    $do->find();

    $prevDept=-1;

    $display = array();
    $links = array();

    while($do->fetch()){
        $do->getLinks();

        // Create relative page link (anchor)
        $links[] = "<a href=\"#{$do->NewsID}\">{$do->Title}</a>";

        // Generate Tile and Article HTML
        $display[] = "<a name='{$do->NewsID}'></a><h3 style='padding: 0; margin: 0;'>{$do->Title}</h3>\n".
          "\t\t<p class=\"byline\">Created on ".
            date('g:ia n/j/Y',strtotime($do->CreationStamp)).
            " by {$do->Employee_Display}</p>\n".
          "<p style='border: 1px solid lightgray'>{$do->Text}</p>\n";
        if (!isset($prevDept) || $prevDept!=$do->toValue('dl_Description')) {
            if (is_null($do->toValue('dl_Description'))) {
                if (isset($prevDept) && !is_null($prevDept)) {
                    //$display[] = "\t<div align='left'>Department: Global</div>\n";
                    $prevDept=null;
                }
            } else {
                $display[] = "\tDepartment: ".$do->toValue('dl_Description')."\n";
                $prevDept=$do->toValue('dl_Description');
            }
        }
    }

    if (isset($miniView) && $miniView==TRUE) {
        if (count($links) > 2) {
            echo "\t<ol>\n";

            foreach($links as $value) {
                echo "\t\t<LI>$value</LI>\n";
            }

            echo "\t</OL>\n";
        }
    }

    // Output the $display array
    foreach ($display as $value) {
        echo $value;
    }

    if (ListPerm(sNEWS))
        echo "\t<div align='left'>Read <a href=\"view.php?News\">past announcements</a></div>\n";
?>