<?php
$do = DB_DataObject::factory('Peripherals');

$changeDO = DB_DataObject::factory('Changelog');
$changeDO->TableName = 'Peripherals';
$changeDO->UserIP = $_SERVER['REMOTE_ADDR'];
$changeDO->EmployeeID = $_SESSION['EmployeeID'];

if($ID != NEWID) {
    $do->get($ID);

    if($do->count() < 1)
        exit("No " . lPERIPHERAL . "with that ID");

    $chageDO->Description = lEDITING . ' ' . lPERIPHERAL . "($ID)";
    $changeDO->QueryType = 'UPDATE';
    $text = lEDITING . ' ' . lPERIPHERAL;

    $data = $do->toArray('peripheral_%s');

    if(is_null($do->Department))
        $data['Department'] = 0;
    if(is_null($do->Computer))
        $data['Computer'] = 0;
    if(!is_null($do->ManufactureDate))
        $data['peripheral_ManufactureDate'] = strtotime($do->ManufactureDate);
        
} else {
    $chageDO->Description = $text = lADD_NEW . ' ' . lPERIPHERAL;
    $changeDO->QueryType = 'INSERT';
    $data = array('peripheral_ManufactureDate' => time());
}

$tempDO = DB_DataObject::factory('Vendors');
$tempDO->orderBy('Company');
$tempDO->find();
$vendorOptions = array(0 => 'Unspecified');
while($tempDO->fetch())
    $vendorOptions[$tempDO->ID] = $tempDO->toString();

unset($tempDO);

$tempDO = DB_DataObject::factory('Departments');
$tempDO->orderBy('Description');
$tempDO->find();
$deptOptions = array(0 => 'None');
while($tempDO->fetch())
    $deptOptions[$tempDO->ID] = $tempDO->toString();

unset($tempDO);

$tempDO = DB_DataObject::factory('Computers');
$tempDO->whereAdd('Computers.Flag != 1');
$tempDO->find();
$computerOptions = array(0 => 'None');
while($tempDO->fetch()) {
    $computerOptions[$tempDO->ComputerID] =
        sprintf($settings['ComputerIDFormat'], $tempDO->toValue('ComputerID')) .
            ": " . $tempDO->toValue('Vendor_Display') . " " . $tempDO->toValue('Model');
}

unset($tempDO);

// Load Employees
$tempDO = DB_DataObject::factory('Employees');
$tempDO->orderBy('LastName, FirstName');
$tempDO->find();
$employeeOptions=array(0=>'Unspecified');
while($tempDO->fetch())
    $employeeOptions[$tempDO->EmployeeID]=$tempDO->toString();

unset($tempDO);

$tempDO = DB_DataObject::factory('PeripheralTypes');
$tempDO->find();
$typeOptions= array(0 => 'Unspecified');
while($tempDO->fetch())
    $typeOptions[$tempDO->ID] = $tempDO->toString();

unset($tempDO);

$tempDO = DB_DataObject::factory('Campuses');
$tempDO->orderBy('Description');
$tempDO->find();
$campusOptions=array(0=>'Unspecified');
while($tempDO->fetch())
    $campusOptions[$tempDO->ID]=$tempDO->toString();

unset($tempDO);

$form = new HTML_QuickForm('Peripherals', 'POST', "index.php?Edit=Peripherals&ID=$ID");


// What are we doing?
if($ID == NEWID) {
    $form->addElement('header', null, lADD_NEW . ' ' . lPERIPHERAL);
} elseif(isset($_GET['View']) && $_GET['View'] == 'Peripherals') {
    $form->addElement('header', null, lVIEWING . ' ' . lPERIPHERAL .
                ' "' . sprintf($settings['PeripheralIDFormat'], $ID) . '"');
} else {
    $form->addElement('header', null, lEDITING . ' ' . lPERIPHERAL .
                ' "' . sprintf($settings['PeripheralIDFormat'], $ID) . '"');
}

$form->addElement('hidden', 'peripheral_PeripheralID', $ID);
$form->addElement('select', 'peripheral_Vendor', lVENDOR . ':', $vendorOptions);
$form->addElement('text', 'peripheral_Model', lMODEL . ':');
$form->addElement('text', 'peripheral_Serial', lSERIAL . ':');
$form->addElement('date', 'peripheral_ManufactureDate', 'Manufactured:',
                array('minYear' => '1990', 'maxYear' => date("Y", time()),
                        'language' => 'en', 'format' => 'M d, Y'));
$form->addElement('select', 'peripheral_Department', lDEPT . ':', $deptOptions);
$form->addElement('select', 'peripheral_Employee', lEMPLOYEE . ':', $employeeOptions);
$form->addElement('select', 'peripheral_Computer', lCOMPUTER . ':', $computerOptions);
$form->addElement('select', 'peripheral_Campus', lCAMPUS . ':', $campusOptions);
$form->addElement('text', 'peripheral_Location', lLOCATION . ':');
$form->addElement('select', 'peripheral_PeripheralType', 'Peripheral Type:', $typeOptions);
$form->addElement('text', 'peripheral_Warranty', 'Warranty:', array('size' => 50));
$form->addElement('text', 'peripheral_FQDN', 'FQDN:', array('size' => 50, 'maxlength' => 255));
$form->addElement('text', 'peripheral_IPAddress', 'IP Address:', array('size' => 15, 'maxlength' => 15));
$form->addElement('textarea', 'peripheral_Notes', 'Notes:', array('rows' => 10, 'cols' => 45));

$form->setDefaults($data);

if($showFrozen) {
    $form->freeze();
    $form->display();
} else {
    if($form->validate()) {
        $form->process('processForm', false);
        $changeDO->insert();
        echo my_redirect('index.php?List=Peripherals');
    } else {
        $form->addElement('submit', null, 'Submit');
        $form->display();
    }
}

function processForm($values)
{
    $do = DB_DataObject::factory('Peripherals');

    if($values['peripheral_PeripheralID'] == NEWID) {
        unset($values['peripheral_PeripheralID']);
    } else {
        $do->get($values['peripheral_PeripheralID']);
        $ID = $do->PeripheralID;
    }

    $ret = $do->setFrom($values, 'peripheral_%s');
    $do->ManufactureDate = sprintf("%4d-%02d-%02d",
                                $values['peripheral_ManufactureDate']['Y'],
                                $values['peripheral_ManufactureDate']['M'],
                                $values['peripheral_ManufactureDate']['d']);
                
    if($ret === true) {
        if(isset($values['peripheral_PeripheralID'])) {
            $do->update();
        } else {
            $do->insert();
        }
    }
}

?>
