<?php
    $do = DB_DataObject::factory('Peripherals');
    
    $do->whereAdd('Peripherals.Flag != ' . fDELETED);
    $do->joinAdd(DB_DataObject::factory('PeripheralTypes'), 'LEFT');
    $do->joinAdd(DB_DataObject::factory('Vendors'), 'LEFT');
    $do->joinAdd(DB_DataObject::factory('Campuses'), 'LEFT');
    
    $do->selectAdd();
    $do->selectAdd('Peripherals.PeripheralID,PeripheralTypes.Description,' .
        'CONCAT(Vendors.Company, " ", Peripherals.Model) AS Name,' .
        'CONCAT(Campuses.Description, " ", Peripherals.Location) AS Locale,' .
        'Peripherals.Computer');

    
    if(isset($_GET['Order'])) {
        switch($_GET['Order']) {
            case 'Type':
                $sort = 'Peripherals.PeripheralType';
                break;
            case 'Model':
                $sort = 'Name';
                break;
            case 'Location':
                $sort = 'Locale';
                break;
            case 'Computer':
                $sort = 'Peripherals.Computer';
                break;
        }
    }

    if(isset($sort)) {
        $sort = (isset($_GET['Sort']) && $_GET['Sort'] == 'desc') ?
                    "$sort DESC,Peripherals.PeripheralID" : "$sort ASC,Peripherals.PeripheralID";
    } else {
        $sort = 'Peripherals.PeripheralID';
        if(isset($_GET['Sort']) && $_GET['Sort'] == 'desc')
            $sort .= ' DESC';
    }
    $do->orderBy($sort);

    $table =& new HTML_Table(array('cellpadding' => '0', 'cellspacing' => '0'));
    $table->setAutoGrow(true);

    $newRow = array();

    switch(Permission(sPERIPHERALS)) {
        case pREMV:
            $newRow[] = '';
        case PEDIT:
            $newRow[] = '';
        case pVIEW:
            $newRow[] = '';
        case pLIST:
            $newRow[] = makeSortHeader('ID');
            $newRow[] = makeSortHeader(lPERIPHERALTYPE, 'Type');
            $newRow[] = makeSortHeader(lMODEL, 'Model');
            $newRow[] = makeSortHeader(lLOCATION, 'Locale');
            $newRow[] = makeSortHeader(lCOMPUTER, 'Computer');
    }

    $table->addRow($newRow, null, 'TH');

    $do->find();
    while($do->fetch()) {
        $newRow = array();
        switch(Permission(sPERIPHERALS)) {
            case pREMV:
                $newRow[] = RemoveButton('Peripherals', $do->PeripheralID);
            case pEDIT:
                $newRow[] = EditButton('Peripherals', $do->PeripheralID);
            case pVIEW:
                $newRow[] = ViewButton('Peripherals', $do->PeripheralID);
            case pLIST:
                $newRow[] = sprintf($settings['PeripheralIDFormat'], $do->toValue('PeripheralID'));
                $newRow[] = $do->toValue('Description');
                $newRow[] = $do->toValue('Name');
                $newRow[] = $do->toValue('Locale');

                if($do->toValue('Computer') != 0) {
                    $newRow[] = '<a href="index.php?View=Computers&ID=' . 
                        $do->Computer . '">' .
                        sprintf($settings['ComputerIDFormat'], $do->Computer) .
                        '</a>';
                } else {
                    $newRow[] = '-';
                }
        }

        $newRowID = $table->addRow($newRow);

        $rowAttr = array(
            'id' => 'row'.$do->PeripheralID,
            'onMouseOver'=>"javascript:setColor(".$do->PeripheralID.",'".$settings['bgColorHover']."')",
            'onMouseOut'=>'javascript:origColor('.$do->PeripheralID.')');

        $rowAttr['class'] = ($newRowID % 2) ? 'odd' : 'even';
        $table->setRowAttributes($newRowID, $rowAttr, true);
    }
    $table->updateColAttributes(count($newRow) - 1, 'align="right"');

    if(EditPerm(sPERIPHERALS))
        echo AddNewButton(sPERIPHERALS);

    echo $table->toHTML();
?>
