<?php
    $do = DB_DataObject::factory('Printers');
    $do->whereAdd('Printers.Flag != '.fDELETED);
    $do->joinAdd(DB_DataObject::factory('Vendors'), 'LEFT');
    $subDO = DB_DataObject::factory('Computers');
    $subDO->joinAdd(DB_DataObject::factory('Employees'), 'LEFT');
    $subDO->joinAdd(DB_DataObject::factory('Vendors'), 'LEFT','CVendors');
    $do->joinAdd($subDO, 'LEFT');
    $do->joinAdd(DB_DataObject::factory('Departments'), 'LEFT');
    $do->selectAdd();
    $do->selectAdd('PrinterID, CostPerPage, NetworkReady,
            Departments.Description AS Department, Printers.PurchasedDate,
            CONCAT(Vendors.Company, " ", Printers.Model, " ", Printers.ModelNumber)
                AS PrinterName,
            CONCAT(Employees.FirstName, " ", Employees.LastName)
                AS ComputerOwner,
            CONCAT(CVendors.Company, " ", Computers.Model) AS ComputersName');

    if(isset($_GET['Order'])) {
        if($_GET['Order'] == 'Date')
            $sort = 'PurchasedDate';
        elseif($_GET['Order'] == 'Owner')
            $sort = 'Employees.LastName';
        elseif($_GET['Order'] == 'Vendor')
            $sort = 'PrinterName';
        elseif($_GET['Order'] == 'Cost')
            $sort = 'CostPerPage';

        if (isset($sort))
            $sort .= ' '.$_GET['Sort'];
    }

    $table =& new HTML_Table(array('cellpadding'=>'0', 'cellspacing'=>'0'));
    $table->setAutoGrow(true);

    $newRow = array();

    switch(Permission(sPRINTERS)) {
        case pREMV:
            $newRow[] = '';
        case pEDIT:
            $newRow[] = '';
        case pVIEW:
        case pLIST:
            $newRow[] = makeSortHeader('Make & Model', 'Vendor');
            $newRow[] = makeSortHeader(lLOCATION, 'Owner');
            $newRow[] = makeSortHeader(lDATE_PURCHASED, 'Date');
            $newRow[] = makeSortHeader('CostPg.', 'Cost');
    }

    $table->addRow($newRow, null, 'TH');

    if(isset($sort))
        $do->orderBy($sort);

    $do->find();

    while($do->fetch()) {
        $newRow = array();

        switch(Permission(sPRINTERS)) {
            case pREMV:
                $newRow[] = RemoveButton('Printers', $do->PrinterID);
            case pEDIT:
                $newRow[] = EditButton('Printers', $do->PrinterID);
            case pVIEW:
            case pLIST:
                $newRow[] = $do->toValue('PrinterName');

                // I had to assign the $do toValue method to variables because
                // PHP 4.3.10 kept throwing an error when doing a:
                //  if(empty($do->toValue('x'))) {...}
                $ComputersName = $do->toValue('ComputersName');
                $ComputerOwner = $do->toValue('ComputerOwner');
                $Department = $do->toValue('Department');

                if ($do->NetworkReady == '1' && empty($ComputersName)) {
                    // Networked because Network Ready & no Computer
                    $newRow[] = $Department. ' (Networked)';
                } else {
                    if (empty($ComputersName)) {
                        if (!empty($Department)) {
                            // Assigned to a department only
                            $newRow[] = $Department;
                        } else {
                            // Unassigned
                            $newRow[] = '[Unassigned]';
                        }
                    } else {
                        // Assigned
                        $newRow[] = $ComputerOwner."'s ".$ComputersName;
                    }
                }

                if (is_null($do->PurchasedDate)) {
                    $newRow[]='';
                } else {
                    $newRow[] = strftime("%b %d, %Y",strtotime($do->PurchasedDate));
                }
                $newRow[] = $do->CostPerPage;
        }

        $newRowID = $table->addRow($newRow);

        $rowAttr = array(
            'id'=>'row'.$do->PrinterID,
            'onMouseOver'=>"javascript:setColor(".$do->PrinterID.",'".$settings['bgColorHover']."')",
            'onMouseOut'=>'javascript:origColor('.$do->PrinterID.')');

        if(($newRowID%2) == 0)
                $rowAttr['class'] ='even';
            else
                $rowAttr['class'] = 'odd';

        $table->setRowAttributes($newRowID, $rowAttr, true);
    }

    $table->updateColAttributes(count($newRow) - 1, 'align="right"');

    if (EditPerm(sPRINTERS))
        echo AddNewButton(sPRINTERS);

    echo $table->toHTML();
?>