<?php
$do = DB_DataObject::factory('Reports');
$do->get($ID);

// Get Columns to Display
$DisplayColumns = explode(',', $do->DisplayColumns);

// Open a database connection
$db = &$do->getDatabaseConnection();

// Run the report query
$result = $db->query($do->SQL);

// Die if it didn't work
if (PEAR::isError($result)) {
    die('Invalid report query.');
}

echo '<script language="JavaScript1.2" src="js/highlight.js"'.
                ' type="text/javascript"></script>';

$table =& new HTML_Table(array('cellpadding'=>'0', 'cellspacing'=>'0'));
$table->setAutoGrow(true);
$table->addRow(
    array($do->Title),
    array('colspan'=>count($DisplayColumns)),
    'TH');
$table->addRow($DisplayColumns, null, 'TH');

$rowNum = 0;
while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC)) {
    $rowNum++;
    $newRow = array();
    foreach ($DisplayColumns as $field) {
        $newRow[] = $row[trim($field)];
    }

    $table->addRow($newRow);

    $rowAttr = array(
            'id'=>'row'.$rowNum,
            'onMouseOver'=>"javascript:setColor(".$rowNum.",'".$settings['bgColorHover']."')",
            'onMouseOut'=>'javascript:origColor('.$rowNum.')');

    if(($rowNum%2) == 0)
        $rowAttr['class'] ='even';
    else
        $rowAttr['class'] = 'odd';

    $table->setRowAttributes($rowNum, $rowAttr, true);
}

echo $table->toHTML();

?>