<?php
    $do = DB_DataObject::factory('Software');
    $do->joinAdd(DB_DataObject::factory('Vendors'), 'LEFT');

    $do->whereAdd('Software.Flag != '.fDELETED);
    $do->selectAdd();
    $do->selectAdd('Software.ID,Software.Licenses,' .
            'CONCAT(Vendors.Company," ",Software.Title," ",Software.Version) AS Name');
            
    $sort = (isset($_GET['Sort']) && $_GET['Sort'] == 'desc')
            ? 'DESC' : 'ASC';

    $orderBy = "Name $sort";

    if(isset($_GET['Order']) && $_GET['Order'] == 'Licenses')
        $orderBy = "Software.Licenses $sort,$orderBy";
        
    $do->orderBy($orderBy);

    $do->find();

    $table =& new HTML_Table(array('cellpadding'=>'0', 'cellspacing'=>'0'));

    $newRow = array();
    switch(Permission(sSOFTWARE)) {
        case pREMV:
            $newRow[] = '';
        case pEDIT:
            $newRow[] = '';
        case pVIEW:
            $newRow[] = '';
        case pLIST:
            $newRow[] = makeSortHeader('Name');
            $newRow[] = makeSortHeader('Licenses');
    }

    $table->addRow($newRow, null, 'TH');

    while($do->fetch()) {
        $newRow = array();

        switch(Permission(sSOFTWARE)) {
            case pREMV:
                $newRow[] = RemoveButton(sSOFTWARE, $do->ID);
            case pEDIT:
                $newRow[] = EditButton(sSOFTWARE, $do->ID);
            case pVIEW:
                $newRow[] = ViewButton(sSOFTWARE, $do->ID);
            case pLIST:
                $name = $do->toValue('Name');
                if(!isset($name) || empty($name))
                    $newRow[] = '-';
                else
                    $newRow[] = $name;
                $newRow[] = $do->Licenses;
        }

        $newRowID = $table->addRow($newRow);

        $rowAttr = array(
            'id'=>'row'.$do->ID,
            'onMouseOver'=>"javascript:setColor(".$do->ID.",'".$settings['bgColorHover']."')",
            'onMouseOut'=>'javascript:origColor('.$do->ID.')');

        if(($newRowID%2) == 0)
            $rowAttr['class'] ='even';
        else
            $rowAttr['class'] = 'odd';

        $table->setRowAttributes($newRowID, $rowAttr, true);
    }

    $table->updateColAttributes(count($newRow) - 1, 'align="right"');
    if (EditPerm(sSOFTWARE)) {
        echo AddNewButton(sSOFTWARE);
    }
    echo $table->toHTML();
?>