<?php
$SupportDO = DB_DataObject::factory('Support');

$ChangeDO=DB_DataObject::factory('Changelog');
$ChangeDO->TableName=sSUPPORT;
$ChangeDO->UserIP=$_SERVER['REMOTE_ADDR'];
$ChangeDO->EmployeeID=$_SESSION['EmployeeID'];

if ($ID != NEWID) {
    // UPDATE

    $SupportDO->get($ID);
    $SupportDO->getLink('Employee');
    $SupportDO->getLink('Technician');
    $SupportDO->getLink('SupportStatus');

    $ChangeDO->Description=lEDITING.' '.lSUPPORT." ($ID)";
    $ChangeDO->QueryType='UPDATE';
    $HeaderText = lEDITING.' '.lSUPPORT;

} else {
    // INSERT (NEW)

    $ChangeDO->Description=lADD_NEW.' '.lSUPPORT." ($ID)";
    $ChangeDO->QueryType='INSERT';
    $HeaderText = lADD_NEW.' '.lSUPPORT;

    $SupportDO->StartedDate = iso_datetime();
}

// Load Employees
$tempDO = DB_DataObject::factory('Employees');
$tempDO->orderBy('LastName, FirstName');
$tempDO->find();
$Employees = array(0=>'None');
while($tempDO->fetch()) {
    $Employees[$tempDO->EmployeeID] = $tempDO->toString();
}

// Load Technicians
$tempDO = DB_DataObject::factory('Employees');
$tempDO->orderBy('LastName, FirstName');
$tempDO->whereAdd('ITTechnician = 1');
$tempDO->whereAdd('Flag != '.fDELETED);
$tempDO->find();
$Technicians = array(0=>'Unassigned');
while($tempDO->fetch()) {
    $Technicians[$tempDO->EmployeeID] = $tempDO->toString();
}

// Load Computers
$tempDO = DB_DataObject::factory('Computers');
$tempDO->find();
$Computers = array(0=>'None');
while($tempDO->fetch()) {
    $Computers[$tempDO->ComputerID] = $tempDO->toString();
}

// Load Printers
$tempDO = DB_DataObject::factory('Printers');
$tempDO->find();
$Printers = array(0 => 'None');
while($tempDO->fetch()) {
    $Printers[$tempDO->PrinterID] = $tempDO->toString();
}

// Load Support Statuses
$tempDO = DB_DataObject::factory('SupportStatus');
$tempDO->find();
$Statuses = array();
while($tempDO->fetch()) {
    $Statuses[$tempDO->ID] = $tempDO->toString();
}

$form = new HTML_QuickForm('Support','POST',"index.php?Edit=Support&ID=$ID");

$form->addElement('header', null, $HeaderText);
$form->addElement('hidden', 'support_SupportID', $SupportDO->SupportID);
$form->addElement('text', 'support_StartedDate', 'Date Started:',
    array('size'=>26, 'maxlength'=>30));
$form->addElement('text', 'support_Title', 'Title:',
    array('size'=>40, 'maxlength'=>255));
$form->addElement('select', 'support_Employee', 'Employee:', $Employees);
$form->addElement('select', 'support_Computer', 'Computer:', $Computers);
$form->addElement('select', 'support_Printer', 'Printer:', $Printers);
$form->addElement('select', 'support_SupportStatus', 'Status:', $Statuses);
$form->addElement('textarea', 'support_Description', 'Description:',
    array('rows' => 12, 'cols' => 60));
$form->addElement('select', 'support_Technician', 'Technician:', $Technicians);
$form->addElement('submit', null, 'Submit');

$form->setDefaults($SupportDO->toArray('support_%s'));

// Require a title to be entered
$form->addRule('support_Title', 'Please enter a title.', 'required', null, 'client');

if ($form->validate()) {
    // Form validated, now process data
    $form->process('processForm', false);

    // Insert Changelog
    $ChangeDO->insert();

    echo my_redirect('index.php?List=Support');
} else {
    // Form did NOT validate, let them edit
    if (isset($data))
        $form->setDefaults($data);

    $form->display();
}

/**
 * Insert/Update Function
 */
function processForm($values)
{
    // Create new Support DO to save with
    $do = DB_DataObject::factory('Support');

    // If we're updating an old Support Issue, get all its existing values
    if(is_numeric($values['support_SupportID'])
            && $values['support_SupportID'] != NEWID) {
        $do->get($values['support_SupportID']);
    } else {
        unset($values['support_SupportID']);
    }

    // Set user inputted values
    $do->setFrom($values,'support_%s');

    // Clean up nulls
    if($do->Employee == 0)
        $do->Employee = null;

    if($do->Computer == 0)
        $do->Computer = null;

    if($do->Printer == 0)
        $do->Printer = null;

    if($do->Technician == 0)
        $do->Technician = null;

    // Reformat Date
    $do->StartedDate = $values['support_StartedDate'];

    if(!isset($values['support_SupportID'])) {
        $ID = $do->insert();
        // The previous statement doesn't seem to always return the ID, but
        // the following line seems to get the ID just fine
        $ID = $do->SupportID;
    } else {
        $do->update();
    }
}
?>