<?php
    // Get OrderBy Column and Sort Order

    $OrderBy = 'SupportStatus.ID';
    $Sort = 'ASC';

    if (isset($_GET['Order'])) {
        switch ($_GET['Order']) {
            case 'Title':
                $OrderBy = 'Title';
                break;
            case 'Date':
                $OrderBy = 'StartedDate';
                break;
            case 'Owner':
                $OrderBy = 'Emp.LastName';
                break;
            case 'Technician':
                $OrderBy = 'Tech.LastName';
                break;
            case 'Status':
                $OrderBy = 'SupportStatus.ID';
        }
    }

    if (isset($_GET['Sort'])) {
        switch ($_GET['Sort']) {
            case 'desc':
                $Sort = 'DESC';
                break;
            case 'asc':
                $Sort = 'ASC';
        }
    }

    // Create DataObject for Support Table
    $SupportDO = DB_DataObject::factory('Support');

    // Set OrderBy & Sort
    $SupportDO->orderBy($OrderBy.' '.$Sort);

    // If we're not already ordering by date, let's add that
    if ($OrderBy != 'StartedDate')
        $SupportDO->orderBy('StartedDate DESC');

    // Clear the DataObject's Select clause
    $SupportDO->selectAdd();

    // Create DataObject for Employees Table in order to load Employee & Tech.
    $EmployeesDO = DB_DataObject::factory('Employees');

    // Join Employees to Support in order to load Employees field
    $SupportDO->joinAdd($EmployeesDO, 'LEFT', 'Emp', 'Employee');

    // Join Employees to Support again in order to load Tech. field
    $SupportDO->joinAdd($EmployeesDO, 'LEFT', 'Tech', 'Technician');

    // Create DataObject for SupportStatus Table in order to load Status
    $SupportStatusDO = DB_DataObject::factory('SupportStatus');
    $SupportDO->joinAdd($SupportStatusDO, 'LEFT');

    // Select the proper fields to display in the list
    $SupportDO->selectAdd('Support.*, SupportStatus.Description AS SupportStatusDesc, '.
        'CONCAT(Emp.FirstName, " ", Emp.LastName) AS EmployeeName, '.
        'CONCAT(Tech.FirstName, " ", Tech.LastName) AS TechName');

    // Actually load the Support Table with the proper Joins
    $SupportDO->find();

    $table =& new HTML_Table(array('cellpadding'=>'0', 'cellspacing'=>'0'));
    $table->setAutoGrow(true);

    $newRow = array();

    switch(Permission(sSUPPORT)) {
        case pREMV:
            $newRow[] = '';
        case pEDIT:
            $newRow[] = '';
        case pVIEW:
            $newRow[] = '';
        case pLIST:
            $newRow[] = makeSortHeader(lTITLE, 'Title');
            $newRow[] = makeSortHeader(lEMPLOYEE, 'Owner');
            $newRow[] = makeSortHeader('Technician', 'Technician');
            $newRow[] = makeSortHeader('Opened', 'Date');
            $newRow[] = makeSortHeader(lSUPTSTATUS, 'Status');
    }

    $table->addRow($newRow, null, 'TH');

    while($SupportDO->fetch()) {
        $newRow = array();

        switch(Permission(sSUPPORT)) {
            case pREMV:
                $newRow[] = RemoveButton(sSUPPORT, $SupportDO->SupportID);
            case pEDIT:
                $newRow[] = EditButton(sSUPPORT, $SupportDO->SupportID);
            case pVIEW:
                $newRow[] = ViewButton(sSUPPORT, $SupportDO->SupportID);
            case pLIST:
                $newRow[] = $SupportDO->Title;
                $newRow[] = $SupportDO->EmployeeName;
                $newRow[] = $SupportDO->TechName;
                $newRow[] = $SupportDO->StartedDate;
                $newRow[] = $SupportDO->SupportStatusDesc;
        }

        $newRowID = $table->addRow($newRow);

        $rowAttr = array(
            'id'=>'rowS'.$SupportDO->SupportID,
            'onMouseOver'=>"javascript:setColor('S".$SupportDO->SupportID."','".$settings['bgColorHover']."')",
            'onMouseOut'=>"javascript:origColor('S".$SupportDO->SupportID."')");

        if(($newRowID%2) == 0)
            $rowAttr['class'] ='even';
        else
            $rowAttr['class'] = 'odd';

        $table->setRowAttributes($newRowID, $rowAttr, true);
    }

    if (EditPerm(sSUPPORT))
        echo AddNewButton(sSUPPORT);

    echo $table->toHTML();
?>