<?php
$support = DB_DataObject::factory('support');
$support->get($ID);

// Link tables for full data
if (!$support->SupportType)
    $support->SupportType = -1;

$support->SupportType = $support->getLink("SupportType", "SupportTypes");

if (!$support->SupportStatus)
    $support->SupportStatus = -1;

$support->SupportStatus = $support->getLink("SupportStatus", "SupportStatus");

if (!$support->Employee)
    $support->Employee = -1;

$support->Employee = $support->getLink("Employee", "Employees");

if (!$support->Technician)
    $support->Technician = -1;

$support->Technician = $support->getLink("Technician", "Employees");

if (!$support->Computer)
    $support->Computer = -1;

$support->Computer = $support->getLink("Computer", "Computers");

if ($support->Computer) {
    if (!$support->Computer->Vendor) {
        $support->Computer->Vendor = -1;
    }

    $support->Computer->Vendor = $support->Computer->getLink("Vendor", "Vendors");
}

if (!$support->Printer)
    $support->Printer = -1;

$support->Printer = $support->getLink("Printer", "Printers");

if ($support->Printer) {
    if (!$support->Printer->Vendor) {
        $support->Printer->Vendor = -1;
    }

    $support->Printer->Vendor = $support->Printer->getLink("Vendor", "Vendors");
}

echo "<h2 style=\"margin-bottom: 0\">" . $support->Title . "</h2>\n".
    $support->SupportType->Description . "<br />\n";

$table =& new HTML_Table(array('cellpadding'=>'1', 'cellspacing'=>'0'));
$table->addRow(array('<b>'.lSUPPORT.' ID #:</b> '.$support->SupportID,
    '<b>Technician:</b> '.$support->Technician->FirstName.' '.$support->Technician->LastName,
    '<b>Date Opened:</b> ' . $support->StartedDate));
$table->addRow(array('<b>'.lEMPLOYEE.':</b> '.$support->Employee->FirstName.' '.$support->Employee->LastName,
    '<b>Phone:</b> '.$support->Employee->WorkPhone,
    '<b>Last Update:</b> '.$support->Updated));
$table->addRow(array('<b>'.lCOMPUTER.':</b> '.$support->Computer->Vendor->Company.' '.$support->Computer->Model.' '.$support->Computer->Serial,
    '<b>'.lPRINTER.':</b> '.$support->Printer->Vendor->Company.' '.$support->Printer->Model,
    '<b>'.lSUPTSTATUS.':</b> '.$support->SupportStatus->Description));
$table->addRow(array('<b>Description:</b><br />' . str_replace("\n", '<br />',
    $support->Description)), array('colspan'=>'3'));
echo $table->toHTML();

// This is an "overloaded" AddNewButton call to hack in the SupportID=$ID bit
echo AddNewButton(sSUPPORTLOG, NEWID.'&Issue='.$ID);

// Create SupportLog DataObject
$supportLog = DB_DataObject::factory('SupportLog');

// Set Issue ID which is what we search by
$supportLog->Issue = $ID;

// Load relevant SupportLog Entries
$supportLog->find();

$table =& new HTML_Table(array('cellpadding'=>'1', 'cellspacing'=>'0'));
$table->setAutoGrow(true);
$table->addRow(array('Support Log'), null, 'TH');

while($supportLog->fetch()) {

    if (!$supportLog->Technician) { $supportLog->Technician = -1; }
    $supportLog->Technician = $supportLog->getLink("Technician", "Employees");

    if (!$supportLog->Status) { $supportLog->Status = -1; }
    $supportLog->Status = $supportLog->getLink("Status", "SupportStatus");

    $newRow = array('buttons'=>'');

    switch(Permission(sSUPPORT)) {
        case pREMV:
            $newRow['buttons'] .= RemoveButton(sSUPPORTLOG, $supportLog->ID.'&SupportID='.$supportLog->Issue);
        case pEDIT:
            $newRow['buttons'] .= EditButton(sSUPPORTLOG, $supportLog->ID.'&SupportID='.$supportLog->Issue);
        case pVIEW:
            $newRow['Timestamp'] = strftime($settings['DateFormat'] . " " . $settings['TimeFormat'], strtotime($supportLog->Timestamp));
            $newRow['TechnicianName'] = $supportLog->Technician->FirstName . " " . $supportLog->Technician->LastName;
            $newRow['Description'] = $supportLog->Description;
            $newRow['Status'] = $supportLog->Status->Description;
    }

    $SupportLogEntry = $newRow['buttons'].'<br />'.
        str_replace("\n", "<br>", $newRow['Description']).'<br />'.
        'Posted by <b>'.$newRow['TechnicianName'].'</b> @ '.
        $newRow['Timestamp'].'. Status: <b>'.$newRow['Status'].'</b>';

    $table->addRow(array($SupportLogEntry));
}

echo $table->toHTML();
?>