<?php
/* Address Lookup Tool
 * This tool can be used to automatically lookup IPs for hostnames in the
 * Computers table.  Its default behavior is to update changed IPs, and remove
 * IPs for hosts that do not appear to be up.
 *
 * This script can be executed from the command line or web.
 */ 

chdir(dirname(__FILE__).'/../');
require_once('inc/settings.php');
$query = 'SELECT ID, Hostname, IPAddress FROM Computers WHERE LENGTH(Hostname)>0';

$res = $db->query($query);

if(DB::isError($res))
    die($res->getMessage() . "\n" . $res->getDebugInfo());

while($row = $res->fetchRow()) {
    echo "Initial:\t".$row['Hostname']."\t".$row['IPAddress']."\n";
    $ip = gethostbyname($row['Hostname']);
    
    if($ip == $row['Hostname'] && !empty($row['IPAddress'])) {
        echo "Not found:\t".$row['Hostname']."\n";
        $db->query('UPDATE Computers SET IPAddress=null WHERE ID='.$row['ID']);
    }
    elseif($ip != $row['Hostname'] && $row['IPAddress'] != $ip) {
        echo "Updated:\t".$row['Hostname']."\t".$ip."\n";
        $db->query('UPDATE Computers SET IPAddress="'.$ip.'" WHERE ID='.$row['ID']);
    }
    echo "\n";
}
?>