-- MySQL dump 9.11
--
-- Host: localhost    Database: openit
-- ------------------------------------------------------
-- Server version	4.0.22

--
-- Table structure for table `Campuses`
--

CREATE TABLE Campuses (
  ID int(11) unsigned NOT NULL auto_increment,
  Description varchar(50) default NULL,
  Flag tinyint(1) unsigned NOT NULL default '0',
  PRIMARY KEY  (ID),
  KEY Flag (Flag)
) TYPE=MyISAM;

--
-- Table structure for table `Changelog`
--

CREATE TABLE Changelog (
  ID int(10) unsigned NOT NULL auto_increment,
  Timestamp datetime NOT NULL default '0000-00-00 00:00:00',
  UserIP char(15) default '',
  TableName char(25) default NULL,
  ChangeID int(10) unsigned default '0',
  QueryType char(6) default '',
  Description char(200) default '',
  EmployeeID int(10) unsigned default NULL,
  PRIMARY KEY  (ID)
) TYPE=MyISAM;

--
-- Table structure for table `Computers`
--

CREATE TABLE Computers (
  ComputerID int(10) unsigned NOT NULL auto_increment,
  Vendor int(11) unsigned default NULL,
  Model varchar(50) default NULL,
  Serial varchar(50) default NULL,
  Location varchar(50) default NULL,
  Campus int(11) unsigned default NULL,
  Department int(11) unsigned default NULL,
  Employee int(11) unsigned default NULL,
  ManufacturedDate date default NULL,
  Warranty varchar(75) default NULL,
  Laptop tinyint(1) default NULL,
  OperatingSystem int(11) unsigned default NULL,
  CPU varchar(50) default NULL,
  RAM int(11) unsigned default NULL,
  Role int(11) unsigned default NULL,
  FQDN varchar(255) default NULL,
  IPAddress varchar(15) default NULL,
  Workgroup varchar(50) default NULL,
  Notes mediumtext,
  Flag tinyint(1) unsigned NOT NULL default '0',
  PRIMARY KEY  (ComputerID),
  KEY Flag (Flag)
) TYPE=MyISAM;

--
-- Table structure for table `Departments`
--

CREATE TABLE Departments (
  ID int(11) unsigned NOT NULL auto_increment,
  Description varchar(50) default NULL,
  Flag tinyint(4) NOT NULL default '0',
  PRIMARY KEY  (ID),
  KEY Flag (Flag)
) TYPE=MyISAM;

--
-- Table structure for table `Employees`
--

CREATE TABLE Employees (
  EmployeeID int(10) unsigned NOT NULL auto_increment,
  Contractor tinyint(1) NOT NULL default '0',
  ITTechnician tinyint(1) NOT NULL default '0',
  FirstName varchar(50) default NULL,
  LastName varchar(50) default NULL,
  MiddleInitial varchar(50) default NULL,
  Department int(10) unsigned default NULL,
  Campus int(10) unsigned default NULL,
  WorkPhone varchar(14) default NULL,
  HomePhone varchar(14) default NULL,
  MobilePhone varchar(14) default NULL,
  Fax varchar(14) default NULL,
  EmailAddress varchar(50) default NULL,
  Notes varchar(255) default NULL,
  HomeStreetAddress varchar(75) default NULL,
  HomePOBox varchar(25) default NULL,
  HomeCity varchar(50) default NULL,
  HomeState char(2) default NULL,
  HomeZip varchar(12) default NULL,
  Password varchar(127) default NULL,
  GroupID int(10) unsigned NOT NULL default '1',
  Language varchar(25) default NULL,
  JabberAccount varchar(255) default NULL,
  PreferredNotification enum('email','jabber','none') NOT NULL default 'none',
  Flag tinyint(4) NOT NULL default '0',
  PRIMARY KEY  (EmployeeID),
  KEY Flag (Flag)
) TYPE=MyISAM;

--
-- Table structure for table `Groups`
--

CREATE TABLE Groups (
  GroupID int(10) unsigned NOT NULL auto_increment,
  Name char(127) NOT NULL default '',
  ComputersPerm tinyint(4) NOT NULL default '0',
  PrintersPerm tinyint(4) NOT NULL default '0',
  PeripheralsPerm tinyint(4) NOT NULL default '0',
  SoftwarePerm tinyint(4) NOT NULL default '0',
  EmployeesPerm tinyint(4) NOT NULL default '2',
  ReportsPerm tinyint(4) NOT NULL default '0',
  SupportPerm tinyint(4) NOT NULL default '1',
  KBPerm tinyint(4) NOT NULL default '2',
  LookupsPerm tinyint(4) NOT NULL default '0',
  NewsPerm tinyint(4) NOT NULL default '1',
  GroupPerm int(11) NOT NULL default '0',
  OutOfOfficePerm int(11) NOT NULL default '1',
  PolicyPerm int(11) NOT NULL default '0',
  Flag tinyint(4) NOT NULL default '0',
  PRIMARY KEY  (GroupID),
  UNIQUE KEY Name (Name),
  KEY Flag (Flag)
) TYPE=MyISAM;

--
-- Table structure for table `Installations`
--

CREATE TABLE Installations (
  ID int(10) unsigned NOT NULL auto_increment,
  Computer int(10) unsigned NOT NULL default '0',
  Software int(10) unsigned NOT NULL default '0',
  SerialNumber char(40) default NULL,
  DateInstalled date default NULL,
  DateUpdated date default NULL,
  Flag tinyint(1) unsigned NOT NULL default '0',
  PRIMARY KEY  (ID),
  KEY Flag (Flag)
) TYPE=MyISAM;

--
-- Table structure for table `KBCategories`
--

CREATE TABLE KBCategories (
  KBCategoryID int(10) unsigned NOT NULL auto_increment,
  Description varchar(100) NOT NULL default '',
  Flag tinyint(4) NOT NULL default '0',
  PRIMARY KEY  (KBCategoryID),
  KEY Flag (Flag)
) TYPE=MyISAM;

--
-- Table structure for table `KnowledgeBase`
--

CREATE TABLE KnowledgeBase (
  KBID int(10) unsigned NOT NULL auto_increment,
  KBCategory int(10) unsigned default '0',
  Keywords varchar(255) default NULL,
  Title varchar(255) default NULL,
  Article text NOT NULL,
  Created datetime NOT NULL default '0000-00-00 00:00:00',
  Updated datetime NOT NULL default '0000-00-00 00:00:00',
  Flag tinyint(4) NOT NULL default '0',
  PRIMARY KEY  (KBID),
  KEY Flag (Flag),
  FULLTEXT KEY Keywords (Keywords)
) TYPE=MyISAM;

--
-- Table structure for table `News`
--

CREATE TABLE News (
  NewsID int(10) unsigned NOT NULL auto_increment,
  CreationStamp datetime NOT NULL default '0000-00-00 00:00:00',
  EmployeeID int(10) unsigned NOT NULL default '0',
  Title varchar(30) NOT NULL default '',
  Text text NOT NULL,
  ExpirationTime datetime default NULL,
  Flag tinyint(4) NOT NULL default '0',
  PRIMARY KEY  (NewsID),
  KEY Flag (Flag)
) TYPE=MyISAM;

--
-- Table structure for table `News_Departments`
--

CREATE TABLE News_Departments (
  NewsID int(11) NOT NULL default '0',
  DepartmentID int(11) NOT NULL default '0',
  Flag tinyint(4) NOT NULL default '0',
  PRIMARY KEY  (NewsID,DepartmentID),
  KEY Flag (Flag)
) TYPE=MyISAM;

--
-- Table structure for table `OutOfOffice`
--

CREATE TABLE OutOfOffice (
  ID int(10) unsigned NOT NULL auto_increment,
  Employee int(10) unsigned NOT NULL default '0',
  Out datetime NOT NULL default '0000-00-00 00:00:00',
  Back datetime default '0000-00-00 00:00:00',
  Description char(255) default '',
  PRIMARY KEY  (ID)
) TYPE=MyISAM;

--
-- Table structure for table `PeripheralTypes`
--

CREATE TABLE PeripheralTypes (
  ID int(10) unsigned NOT NULL auto_increment,
  Description char(25) NOT NULL default '',
  Flag tinyint(4) NOT NULL default '0',
  PRIMARY KEY  (ID),
  KEY Flag (Flag)
) TYPE=MyISAM;

--
-- Table structure for table `Peripherals`
--

CREATE TABLE Peripherals (
  PeripheralID int(10) unsigned NOT NULL auto_increment,
  Vendor int(11) unsigned default NULL,
  Model varchar(50) default '',
  Serial varchar(50) default NULL,
  Location varchar(50) default NULL,
  Campus int(11) unsigned default NULL,
  Department int(11) unsigned default NULL,
  Employee int(11) unsigned default NULL,
  ManufactureDate date default NULL,
  Warranty varchar(75) default NULL,
  Computer int(11) unsigned default NULL,
  FQDN varchar(255) default NULL,
  IPAddress varchar(15) default NULL,
  PeripheralType int(10) NOT NULL default '1',
  Flag tinyint(1) unsigned NOT NULL default '0',
  Notes mediumtext,
  PRIMARY KEY  (PeripheralID),
  KEY Flag (Flag)
) TYPE=MyISAM;

--
-- Table structure for table `Policies`
--

CREATE TABLE Policies (
  PolicyID int(10) unsigned NOT NULL auto_increment,
  Flag tinyint(1) unsigned NOT NULL default '0',
  Category int(10) unsigned default '0',
  Title varchar(255) default NULL,
  PRIMARY KEY  (PolicyID),
  KEY Flag (Flag)
) TYPE=MyISAM;

--
-- Table structure for table `Policies_Employees`
--

CREATE TABLE Policies_Employees (
  ID int(10) unsigned NOT NULL auto_increment,
  Employee int(10) unsigned NOT NULL default '0',
  PolicyText int(10) unsigned NOT NULL default '0',
  Flag tinyint(1) unsigned NOT NULL default '0',
  ViewedOn datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (ID),
  UNIQUE KEY EmployeePolicy (Employee,PolicyText),
  KEY Flag (Flag)
) TYPE=MyISAM;

--
-- Table structure for table `PolicyCategories`
--

CREATE TABLE PolicyCategories (
  ID int(10) unsigned NOT NULL auto_increment,
  Flag tinyint(1) unsigned NOT NULL default '0',
  Description varchar(100) NOT NULL default '',
  PRIMARY KEY  (ID),
  KEY Flag (Flag)
) TYPE=MyISAM;

--
-- Table structure for table `PolicyText`
--

CREATE TABLE PolicyText (
  PolicyTextID int(10) unsigned NOT NULL auto_increment,
  Policy int(10) unsigned NOT NULL default '0',
  Version int(10) unsigned NOT NULL default '1',
  Author int(10) unsigned NOT NULL default '0',
  Flag tinyint(3) unsigned NOT NULL default '0',
  Created datetime NOT NULL default '0000-00-00 00:00:00',
  Text text NOT NULL,
  PRIMARY KEY  (PolicyTextID),
  KEY Flag (Flag),
  KEY Policy (Policy)
) TYPE=MyISAM;

--
-- Table structure for table `PrinterTypes`
--

CREATE TABLE PrinterTypes (
  ID int(10) unsigned NOT NULL auto_increment,
  Description char(25) NOT NULL default '',
  Flag tinyint(4) NOT NULL default '0',
  PRIMARY KEY  (ID),
  KEY Flag (Flag)
) TYPE=MyISAM;

--
-- Table structure for table `Printers`
--

CREATE TABLE Printers (
  PrinterID int(10) unsigned NOT NULL auto_increment,
  Vendor int(10) unsigned default '0',
  Model varchar(100) default '',
  ModelNumber varchar(100) default '',
  SerialNumber varchar(25) default NULL,
  PurchasedDate date default NULL,
  Computer int(10) unsigned default '0',
  Department int(10) unsigned default NULL,
  CostPerPage decimal(4,2) default NULL,
  NetworkReady varchar(100) NOT NULL default '0',
  Multifunction tinyint(4) NOT NULL default '0',
  PrinterType int(11) NOT NULL default '1',
  Notes varchar(255) default NULL,
  Flag tinyint(4) NOT NULL default '0',
  PRIMARY KEY  (PrinterID),
  KEY Flag (Flag)
) TYPE=MyISAM;

--
-- Table structure for table `Role`
--

CREATE TABLE Role (
  ID int(11) unsigned NOT NULL auto_increment,
  Description char(50) default NULL,
  InUse tinyint(1) unsigned NOT NULL default '1',
  Flag tinyint(4) NOT NULL default '0',
  PRIMARY KEY  (ID),
  KEY Flag (Flag)
) TYPE=MyISAM;

--
-- Table structure for table `Software`
--

CREATE TABLE Software (
  ID int(10) unsigned NOT NULL auto_increment,
  Vendor int(11) default '1',
  Title char(50) NOT NULL default '',
  Version char(25) default NULL,
  Licenses mediumint(9) default NULL,
  ManufacturedDate date default NULL,
  Website char(200) default NULL,
  isOS tinyint(1) NOT NULL default '0',
  Flag tinyint(4) NOT NULL default '0',
  PRIMARY KEY  (ID),
  KEY Flag (Flag)
) TYPE=MyISAM;

--
-- Table structure for table `Support`
--

CREATE TABLE Support (
  SupportID int(11) unsigned NOT NULL auto_increment,
  StartedDate datetime default NULL,
  Updated datetime NOT NULL default '0000-00-00 00:00:00',
  Title varchar(100) NOT NULL default '',
  Computer int(11) unsigned default NULL,
  Printer int(10) unsigned default '0',
  Employee int(11) default '0',
  SupportType int(11) unsigned default NULL,
  Description text,
  SupportStatus int(11) unsigned default NULL,
  Technician int(11) unsigned default NULL,
  PRIMARY KEY  (SupportID)
) TYPE=MyISAM;

--
-- Table structure for table `SupportLog`
--

CREATE TABLE SupportLog (
  ID int(10) unsigned NOT NULL auto_increment,
  Timestamp datetime NOT NULL default '0000-00-00 00:00:00',
  Issue int(10) unsigned NOT NULL default '0',
  Technician int(10) unsigned NOT NULL default '0',
  Description text,
  Status int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (ID)
) TYPE=MyISAM;

--
-- Table structure for table `SupportStatus`
--

CREATE TABLE SupportStatus (
  ID int(11) unsigned NOT NULL auto_increment,
  Description char(25) default NULL,
  Closed tinyint(1) default NULL,
  Flag tinyint(4) NOT NULL default '0',
  PRIMARY KEY  (ID),
  KEY Flag (Flag)
) TYPE=MyISAM;

--
-- Table structure for table `SupportTypes`
--

CREATE TABLE SupportTypes (
  ID int(11) unsigned NOT NULL auto_increment,
  Description char(50) default NULL,
  Hardware tinyint(1) default NULL,
  Preventative tinyint(1) default NULL,
  Flag tinyint(4) NOT NULL default '0',
  PRIMARY KEY  (ID),
  KEY Flag (Flag)
) TYPE=MyISAM;

--
-- Table structure for table `Vendors`
--

CREATE TABLE Vendors (
  ID int(11) unsigned NOT NULL auto_increment,
  Company char(50) default NULL,
  Flag tinyint(4) NOT NULL default '0',
  PRIMARY KEY  (ID),
  KEY Flag (Flag)
) TYPE=MyISAM;

